
module MenhirBasics = struct
  
  exception Error
  
  type token = 
    | STRING_KEYWORD
    | STRINGS
    | STRING of (
# 82 "src/parser.mly"
       (Ast.substs)
# 13 "src/parser.ml"
  )
    | SEMICOLON
    | RIGHT_PAREN
    | RIGHT_ARRAY
    | RETURNING
    | PURE
    | PREDICATE
    | PRED of (
# 85 "src/parser.mly"
       (string)
# 24 "src/parser.ml"
  )
    | OPTINCLUDE
    | LET
    | LEFT_PAREN
    | LEFT_ARRAY
    | INCLUDE
    | ID of (
# 71 "src/parser.mly"
       (string)
# 34 "src/parser.ml"
  )
    | GOAL
    | FUNCTION
    | EXPRESSION
    | EQUALS
    | EOF
    | COMMA
    | COLON
    | CODE of (
# 63 "src/parser.mly"
       (Ast.code)
# 46 "src/parser.ml"
  )
  
end

include MenhirBasics

let _eRR =
  MenhirBasics.Error

type _menhir_env = {
  _menhir_lexer: Lexing.lexbuf -> token;
  _menhir_lexbuf: Lexing.lexbuf;
  _menhir_token: token;
  mutable _menhir_error: bool
}

and _menhir_state = 
  | MenhirState82
  | MenhirState77
  | MenhirState72
  | MenhirState65
  | MenhirState61
  | MenhirState58
  | MenhirState56
  | MenhirState51
  | MenhirState48
  | MenhirState45
  | MenhirState40
  | MenhirState32
  | MenhirState28
  | MenhirState27
  | MenhirState17
  | MenhirState9
  | MenhirState5
  | MenhirState4
  | MenhirState3
  | MenhirState2
  | MenhirState0

# 20 "src/parser.mly"
  
open Utils
open Printf

(* There are several circular dependencies between the lexer
 * (caused by includes) and eval.  These references break
 * the circular dependencies.  They are initialized when
 * the program starts, hence are never really None.
 *)
let lexer_read = ref None
let eval_substitute = ref None

let find_on_include_path filename =
  if not (Filename.is_implicit filename) then filename
  else (
    let rec loop = function
      | [] -> filename
      | inc :: incs ->
         let path = inc // filename in
         if Sys.file_exists path then path else loop incs
    in
    loop (Cmdline.includes ())
  )

let do_include env loc filename optflag file =
  let eval_substitute =
    match !eval_substitute with None -> assert false | Some f -> f in
  let filename = eval_substitute env loc filename in
  let filename = find_on_include_path filename in
  if optflag && not (Sys.file_exists filename) then env
  else (
    let fp = open_in filename in
    let lexbuf = Lexing.from_channel fp in
    lexbuf.lex_curr_p <- { lexbuf.lex_curr_p with pos_fname = filename };
    let lexer_read =
      match !lexer_read with None -> assert false | Some r -> r in
    let env' = file lexer_read lexbuf in
    close_in fp;
    Ast.Env.merge env env'
  )

# 128 "src/parser.ml"

let rec _menhir_goto_separated_nonempty_list_COMMA_pattern_ : _menhir_env -> 'ttv_tail -> _menhir_state -> 'tv_separated_nonempty_list_COMMA_pattern_ -> 'ttv_return =
  fun _menhir_env _menhir_stack _menhir_s _v ->
    match _menhir_s with
    | MenhirState58 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv403) = Obj.magic _menhir_stack in
        let (_menhir_s : _menhir_state) = _menhir_s in
        let (_v : 'tv_separated_nonempty_list_COMMA_pattern_) = _v in
        ((let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv401) = Obj.magic _menhir_stack in
        let (_menhir_s : _menhir_state) = _menhir_s in
        let ((x : 'tv_separated_nonempty_list_COMMA_pattern_) : 'tv_separated_nonempty_list_COMMA_pattern_) = _v in
        ((let _v : 'tv_loption_separated_nonempty_list_COMMA_pattern__ = 
# 144 "<standard.mly>"
    ( x )
# 145 "src/parser.ml"
         in
        _menhir_goto_loption_separated_nonempty_list_COMMA_pattern__ _menhir_env _menhir_stack _menhir_s _v) : 'freshtv402)) : 'freshtv404)
    | MenhirState77 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv407 * _menhir_state * 'tv_pattern) * Lexing.position) = Obj.magic _menhir_stack in
        let (_menhir_s : _menhir_state) = _menhir_s in
        let (_v : 'tv_separated_nonempty_list_COMMA_pattern_) = _v in
        ((let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv405 * _menhir_state * 'tv_pattern) * Lexing.position) = Obj.magic _menhir_stack in
        let (_ : _menhir_state) = _menhir_s in
        let ((xs : 'tv_separated_nonempty_list_COMMA_pattern_) : 'tv_separated_nonempty_list_COMMA_pattern_) = _v in
        ((let ((_menhir_stack, _menhir_s, (x : 'tv_pattern)), _endpos__2_) = _menhir_stack in
        let _2 = () in
        let _v : 'tv_separated_nonempty_list_COMMA_pattern_ = 
# 243 "<standard.mly>"
    ( x :: xs )
# 162 "src/parser.ml"
         in
        _menhir_goto_separated_nonempty_list_COMMA_pattern_ _menhir_env _menhir_stack _menhir_s _v) : 'freshtv406)) : 'freshtv408)
    | _ ->
        _menhir_fail ()

and _menhir_goto_separated_nonempty_list_COMMA_pattern_param_ : _menhir_env -> 'ttv_tail -> _menhir_state -> 'tv_separated_nonempty_list_COMMA_pattern_param_ -> 'ttv_return =
  fun _menhir_env _menhir_stack _menhir_s _v ->
    match _menhir_s with
    | MenhirState61 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv395) = Obj.magic _menhir_stack in
        let (_menhir_s : _menhir_state) = _menhir_s in
        let (_v : 'tv_separated_nonempty_list_COMMA_pattern_param_) = _v in
        ((let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv393) = Obj.magic _menhir_stack in
        let (_menhir_s : _menhir_state) = _menhir_s in
        let ((x : 'tv_separated_nonempty_list_COMMA_pattern_param_) : 'tv_separated_nonempty_list_COMMA_pattern_param_) = _v in
        ((let _v : 'tv_loption_separated_nonempty_list_COMMA_pattern_param__ = 
# 144 "<standard.mly>"
    ( x )
# 183 "src/parser.ml"
         in
        _menhir_goto_loption_separated_nonempty_list_COMMA_pattern_param__ _menhir_env _menhir_stack _menhir_s _v) : 'freshtv394)) : 'freshtv396)
    | MenhirState65 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv399 * _menhir_state * 'tv_pattern_param) * Lexing.position) = Obj.magic _menhir_stack in
        let (_menhir_s : _menhir_state) = _menhir_s in
        let (_v : 'tv_separated_nonempty_list_COMMA_pattern_param_) = _v in
        ((let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv397 * _menhir_state * 'tv_pattern_param) * Lexing.position) = Obj.magic _menhir_stack in
        let (_ : _menhir_state) = _menhir_s in
        let ((xs : 'tv_separated_nonempty_list_COMMA_pattern_param_) : 'tv_separated_nonempty_list_COMMA_pattern_param_) = _v in
        ((let ((_menhir_stack, _menhir_s, (x : 'tv_pattern_param)), _endpos__2_) = _menhir_stack in
        let _2 = () in
        let _v : 'tv_separated_nonempty_list_COMMA_pattern_param_ = 
# 243 "<standard.mly>"
    ( x :: xs )
# 200 "src/parser.ml"
         in
        _menhir_goto_separated_nonempty_list_COMMA_pattern_param_ _menhir_env _menhir_stack _menhir_s _v) : 'freshtv398)) : 'freshtv400)
    | _ ->
        _menhir_fail ()

and _menhir_goto_option_CODE_ : _menhir_env -> 'ttv_tail -> Lexing.position -> 'tv_option_CODE_ -> 'ttv_return =
  fun _menhir_env _menhir_stack _endpos _v ->
    let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : ((('freshtv391 * 'tv_option_goal_stmt_ * Lexing.position) * _menhir_state * 'tv_patterns) * Lexing.position) * Lexing.position * _menhir_state * 'tv_barelist) = Obj.magic _menhir_stack in
    let (_endpos : Lexing.position) = _endpos in
    let (_v : 'tv_option_CODE_) = _v in
    ((let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : ((('freshtv389 * 'tv_option_goal_stmt_ * Lexing.position) * _menhir_state * 'tv_patterns) * Lexing.position) * Lexing.position * _menhir_state * 'tv_barelist) = Obj.magic _menhir_stack in
    let (_endpos__5_ : Lexing.position) = _endpos in
    let ((_5 : 'tv_option_CODE_) : 'tv_option_CODE_) = _v in
    ((let ((((_menhir_stack, (_1 : 'tv_option_goal_stmt_), _startpos__1_), _, (_2 : 'tv_patterns)), _endpos__3_), _endpos__4_, _, (_4 : 'tv_barelist)) = _menhir_stack in
    let _3 = () in
    let _endpos = _endpos__5_ in
    let _v : 'tv_stmt = let _endpos = _endpos__5_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    
# 109 "src/parser.mly"
    ( let name, params =
        match _1 with
        | None ->
           sprintf "_goal@%d" _startpos.pos_lnum, []
        | Some x -> x in
      name, Ast.EGoalDefn (_loc, (params, _2, _4, _5))
    )
# 231 "src/parser.ml"
     in
    _menhir_goto_stmt _menhir_env _menhir_stack _endpos _v) : 'freshtv390)) : 'freshtv392)

and _menhir_goto_pattern : _menhir_env -> 'ttv_tail -> _menhir_state -> 'tv_pattern -> 'ttv_return =
  fun _menhir_env _menhir_stack _menhir_s _v ->
    let _menhir_stack = (_menhir_stack, _menhir_s, _v) in
    let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : 'freshtv387 * _menhir_state * 'tv_pattern) = Obj.magic _menhir_stack in
    ((assert (not _menhir_env._menhir_error);
    let _tok = _menhir_env._menhir_token in
    match _tok with
    | COMMA ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv381 * _menhir_state * 'tv_pattern) = Obj.magic _menhir_stack in
        let (_endpos : Lexing.position) = _menhir_env._menhir_lexbuf.Lexing.lex_curr_p in
        ((let _menhir_stack = (_menhir_stack, _endpos) in
        let _menhir_env = _menhir_discard _menhir_env in
        let _tok = _menhir_env._menhir_token in
        match _tok with
        | PRED _v ->
            _menhir_run60 _menhir_env (Obj.magic _menhir_stack) MenhirState77 _v _menhir_env._menhir_lexbuf.Lexing.lex_start_p
        | STRING _v ->
            _menhir_run59 _menhir_env (Obj.magic _menhir_stack) _menhir_env._menhir_lexbuf.Lexing.lex_curr_p MenhirState77 _v _menhir_env._menhir_lexbuf.Lexing.lex_start_p
        | _ ->
            assert (not _menhir_env._menhir_error);
            _menhir_env._menhir_error <- true;
            _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState77) : 'freshtv382)
    | COLON ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv383 * _menhir_state * 'tv_pattern) = Obj.magic _menhir_stack in
        ((let (_menhir_stack, _menhir_s, (x : 'tv_pattern)) = _menhir_stack in
        let _v : 'tv_separated_nonempty_list_COMMA_pattern_ = 
# 241 "<standard.mly>"
    ( [ x ] )
# 266 "src/parser.ml"
         in
        _menhir_goto_separated_nonempty_list_COMMA_pattern_ _menhir_env _menhir_stack _menhir_s _v) : 'freshtv384)
    | _ ->
        assert (not _menhir_env._menhir_error);
        _menhir_env._menhir_error <- true;
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv385 * _menhir_state * 'tv_pattern) = Obj.magic _menhir_stack in
        ((let (_menhir_stack, _menhir_s, _) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv386)) : 'freshtv388)

and _menhir_goto_loption_separated_nonempty_list_COMMA_pattern_param__ : _menhir_env -> 'ttv_tail -> _menhir_state -> 'tv_loption_separated_nonempty_list_COMMA_pattern_param__ -> 'ttv_return =
  fun _menhir_env _menhir_stack _menhir_s _v ->
    let _menhir_stack = (_menhir_stack, _menhir_s, _v) in
    let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : ('freshtv379) * _menhir_state * 'tv_loption_separated_nonempty_list_COMMA_pattern_param__) = Obj.magic _menhir_stack in
    ((assert (not _menhir_env._menhir_error);
    let _tok = _menhir_env._menhir_token in
    match _tok with
    | RIGHT_PAREN ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv375) * _menhir_state * 'tv_loption_separated_nonempty_list_COMMA_pattern_param__) = Obj.magic _menhir_stack in
        let (_endpos : Lexing.position) = _menhir_env._menhir_lexbuf.Lexing.lex_curr_p in
        ((let _menhir_env = _menhir_discard _menhir_env in
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv373) * _menhir_state * 'tv_loption_separated_nonempty_list_COMMA_pattern_param__) = Obj.magic _menhir_stack in
        let (_endpos__3_ : Lexing.position) = _endpos in
        ((let (_menhir_stack, _, (xs : 'tv_loption_separated_nonempty_list_COMMA_pattern_param__)) = _menhir_stack in
        let _3 = () in
        let _1 = () in
        let _endpos = _endpos__3_ in
        let _v : 'tv_pattern_params = let _2 = 
# 232 "<standard.mly>"
    ( xs )
# 300 "src/parser.ml"
         in
        
# 159 "src/parser.mly"
                                                                  ( _2 )
# 305 "src/parser.ml"
         in
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv371) = _menhir_stack in
        let (_endpos : Lexing.position) = _endpos in
        let (_v : 'tv_pattern_params) = _v in
        ((let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv369 * _menhir_state * (
# 85 "src/parser.mly"
       (string)
# 315 "src/parser.ml"
        ) * Lexing.position) = Obj.magic _menhir_stack in
        let (_endpos : Lexing.position) = _endpos in
        let (_v : 'tv_pattern_params) = _v in
        ((let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv367 * _menhir_state * (
# 85 "src/parser.mly"
       (string)
# 323 "src/parser.ml"
        ) * Lexing.position) = Obj.magic _menhir_stack in
        let (_endpos__2_ : Lexing.position) = _endpos in
        let ((_2 : 'tv_pattern_params) : 'tv_pattern_params) = _v in
        ((let (_menhir_stack, _menhir_s, (_1 : (
# 85 "src/parser.mly"
       (string)
# 330 "src/parser.ml"
        )), _startpos__1_) = _menhir_stack in
        let _v : 'tv_pattern = let _endpos = _endpos__2_ in
        let _startpos = _startpos__1_ in
        let _loc = (_startpos, _endpos) in
        
# 156 "src/parser.mly"
                          ( Ast.PPred (_loc, _1, _2) )
# 338 "src/parser.ml"
         in
        _menhir_goto_pattern _menhir_env _menhir_stack _menhir_s _v) : 'freshtv368)) : 'freshtv370)) : 'freshtv372)) : 'freshtv374)) : 'freshtv376)
    | _ ->
        assert (not _menhir_env._menhir_error);
        _menhir_env._menhir_error <- true;
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv377) * _menhir_state * 'tv_loption_separated_nonempty_list_COMMA_pattern_param__) = Obj.magic _menhir_stack in
        ((let (_menhir_stack, _menhir_s, _) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv378)) : 'freshtv380)

and _menhir_run62 : _menhir_env -> 'ttv_tail -> Lexing.position -> _menhir_state -> (
# 82 "src/parser.mly"
       (Ast.substs)
# 352 "src/parser.ml"
) -> Lexing.position -> 'ttv_return =
  fun _menhir_env _menhir_stack _endpos _menhir_s _v _startpos ->
    let _menhir_env = _menhir_discard _menhir_env in
    let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : 'freshtv365) = Obj.magic _menhir_stack in
    let (_endpos__1_ : Lexing.position) = _endpos in
    let (_menhir_s : _menhir_state) = _menhir_s in
    let ((_1 : (
# 82 "src/parser.mly"
       (Ast.substs)
# 363 "src/parser.ml"
    )) : (
# 82 "src/parser.mly"
       (Ast.substs)
# 367 "src/parser.ml"
    )) = _v in
    let (_startpos__1_ : Lexing.position) = _startpos in
    ((let _v : 'tv_pattern_param = 
# 162 "src/parser.mly"
                 ( _1 )
# 373 "src/parser.ml"
     in
    let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : 'freshtv363) = _menhir_stack in
    let (_menhir_s : _menhir_state) = _menhir_s in
    let (_v : 'tv_pattern_param) = _v in
    ((let _menhir_stack = (_menhir_stack, _menhir_s, _v) in
    let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : 'freshtv361 * _menhir_state * 'tv_pattern_param) = Obj.magic _menhir_stack in
    ((assert (not _menhir_env._menhir_error);
    let _tok = _menhir_env._menhir_token in
    match _tok with
    | COMMA ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv355 * _menhir_state * 'tv_pattern_param) = Obj.magic _menhir_stack in
        let (_endpos : Lexing.position) = _menhir_env._menhir_lexbuf.Lexing.lex_curr_p in
        ((let _menhir_stack = (_menhir_stack, _endpos) in
        let _menhir_env = _menhir_discard _menhir_env in
        let _tok = _menhir_env._menhir_token in
        match _tok with
        | STRING _v ->
            _menhir_run62 _menhir_env (Obj.magic _menhir_stack) _menhir_env._menhir_lexbuf.Lexing.lex_curr_p MenhirState65 _v _menhir_env._menhir_lexbuf.Lexing.lex_start_p
        | _ ->
            assert (not _menhir_env._menhir_error);
            _menhir_env._menhir_error <- true;
            _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState65) : 'freshtv356)
    | RIGHT_PAREN ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv357 * _menhir_state * 'tv_pattern_param) = Obj.magic _menhir_stack in
        ((let (_menhir_stack, _menhir_s, (x : 'tv_pattern_param)) = _menhir_stack in
        let _v : 'tv_separated_nonempty_list_COMMA_pattern_param_ = 
# 241 "<standard.mly>"
    ( [ x ] )
# 406 "src/parser.ml"
         in
        _menhir_goto_separated_nonempty_list_COMMA_pattern_param_ _menhir_env _menhir_stack _menhir_s _v) : 'freshtv358)
    | _ ->
        assert (not _menhir_env._menhir_error);
        _menhir_env._menhir_error <- true;
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv359 * _menhir_state * 'tv_pattern_param) = Obj.magic _menhir_stack in
        ((let (_menhir_stack, _menhir_s, _) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv360)) : 'freshtv362)) : 'freshtv364)) : 'freshtv366)

and _menhir_goto_return_decl : _menhir_env -> 'ttv_tail -> 'tv_return_decl -> 'ttv_return =
  fun _menhir_env _menhir_stack _v ->
    let _menhir_stack = (_menhir_stack, _v) in
    let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : (((('freshtv353 * 'tv_option_PURE_ * Lexing.position)) * Lexing.position * (
# 71 "src/parser.mly"
       (string)
# 424 "src/parser.ml"
    ) * Lexing.position) * _menhir_state * 'tv_params_decl) * 'tv_return_decl) = Obj.magic _menhir_stack in
    ((assert (not _menhir_env._menhir_error);
    let _tok = _menhir_env._menhir_token in
    match _tok with
    | EQUALS ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : (((('freshtv349 * 'tv_option_PURE_ * Lexing.position)) * Lexing.position * (
# 71 "src/parser.mly"
       (string)
# 434 "src/parser.ml"
        ) * Lexing.position) * _menhir_state * 'tv_params_decl) * 'tv_return_decl) = Obj.magic _menhir_stack in
        ((let _menhir_env = _menhir_discard _menhir_env in
        let _tok = _menhir_env._menhir_token in
        match _tok with
        | CODE _v ->
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : ((((('freshtv345 * 'tv_option_PURE_ * Lexing.position)) * Lexing.position * (
# 71 "src/parser.mly"
       (string)
# 444 "src/parser.ml"
            ) * Lexing.position) * _menhir_state * 'tv_params_decl) * 'tv_return_decl)) = Obj.magic _menhir_stack in
            let (_endpos : Lexing.position) = _menhir_env._menhir_lexbuf.Lexing.lex_curr_p in
            let (_v : (
# 63 "src/parser.mly"
       (Ast.code)
# 450 "src/parser.ml"
            )) = _v in
            ((let _menhir_env = _menhir_discard _menhir_env in
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : ((((('freshtv343 * 'tv_option_PURE_ * Lexing.position)) * Lexing.position * (
# 71 "src/parser.mly"
       (string)
# 457 "src/parser.ml"
            ) * Lexing.position) * _menhir_state * 'tv_params_decl) * 'tv_return_decl)) = Obj.magic _menhir_stack in
            let (_endpos__7_ : Lexing.position) = _endpos in
            let ((_7 : (
# 63 "src/parser.mly"
       (Ast.code)
# 463 "src/parser.ml"
            )) : (
# 63 "src/parser.mly"
       (Ast.code)
# 467 "src/parser.ml"
            )) = _v in
            ((let ((((_menhir_stack, (_1 : 'tv_option_PURE_), _startpos__1_), _endpos__3_, (_3 : (
# 71 "src/parser.mly"
       (string)
# 472 "src/parser.ml"
            )), _startpos__3_), _, (_4 : 'tv_params_decl)), (_5 : 'tv_return_decl)) = _menhir_stack in
            let _6 = () in
            let _2 = () in
            let _endpos = _endpos__7_ in
            let _v : 'tv_stmt = let _endpos = _endpos__7_ in
            let _startpos = _startpos__1_ in
            let _loc = (_startpos, _endpos) in
            
# 126 "src/parser.mly"
    (
      _3, Ast.EFuncDefn (_loc, (_4, _5, _1 <> None, _7))
    )
# 485 "src/parser.ml"
             in
            _menhir_goto_stmt _menhir_env _menhir_stack _endpos _v) : 'freshtv344)) : 'freshtv346)
        | _ ->
            assert (not _menhir_env._menhir_error);
            _menhir_env._menhir_error <- true;
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : ((((('freshtv347 * 'tv_option_PURE_ * Lexing.position)) * Lexing.position * (
# 71 "src/parser.mly"
       (string)
# 495 "src/parser.ml"
            ) * Lexing.position) * _menhir_state * 'tv_params_decl) * 'tv_return_decl)) = Obj.magic _menhir_stack in
            ((let ((_menhir_stack, _menhir_s, _), _) = _menhir_stack in
            _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv348)) : 'freshtv350)
    | _ ->
        assert (not _menhir_env._menhir_error);
        _menhir_env._menhir_error <- true;
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : (((('freshtv351 * 'tv_option_PURE_ * Lexing.position)) * Lexing.position * (
# 71 "src/parser.mly"
       (string)
# 506 "src/parser.ml"
        ) * Lexing.position) * _menhir_state * 'tv_params_decl) * 'tv_return_decl) = Obj.magic _menhir_stack in
        ((let ((_menhir_stack, _menhir_s, _), _) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv352)) : 'freshtv354)

and _menhir_goto_separated_nonempty_list_COMMA_param_decl_ : _menhir_env -> 'ttv_tail -> _menhir_state -> 'tv_separated_nonempty_list_COMMA_param_decl_ -> 'ttv_return =
  fun _menhir_env _menhir_stack _menhir_s _v ->
    match _menhir_s with
    | MenhirState28 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv337) = Obj.magic _menhir_stack in
        let (_menhir_s : _menhir_state) = _menhir_s in
        let (_v : 'tv_separated_nonempty_list_COMMA_param_decl_) = _v in
        ((let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv335) = Obj.magic _menhir_stack in
        let (_menhir_s : _menhir_state) = _menhir_s in
        let ((x : 'tv_separated_nonempty_list_COMMA_param_decl_) : 'tv_separated_nonempty_list_COMMA_param_decl_) = _v in
        ((let _v : 'tv_loption_separated_nonempty_list_COMMA_param_decl__ = 
# 144 "<standard.mly>"
    ( x )
# 526 "src/parser.ml"
         in
        _menhir_goto_loption_separated_nonempty_list_COMMA_param_decl__ _menhir_env _menhir_stack _menhir_s _v) : 'freshtv336)) : 'freshtv338)
    | MenhirState32 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv341 * _menhir_state * 'tv_param_decl) * Lexing.position) = Obj.magic _menhir_stack in
        let (_menhir_s : _menhir_state) = _menhir_s in
        let (_v : 'tv_separated_nonempty_list_COMMA_param_decl_) = _v in
        ((let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv339 * _menhir_state * 'tv_param_decl) * Lexing.position) = Obj.magic _menhir_stack in
        let (_ : _menhir_state) = _menhir_s in
        let ((xs : 'tv_separated_nonempty_list_COMMA_param_decl_) : 'tv_separated_nonempty_list_COMMA_param_decl_) = _v in
        ((let ((_menhir_stack, _menhir_s, (x : 'tv_param_decl)), _endpos__2_) = _menhir_stack in
        let _2 = () in
        let _v : 'tv_separated_nonempty_list_COMMA_param_decl_ = 
# 243 "<standard.mly>"
    ( x :: xs )
# 543 "src/parser.ml"
         in
        _menhir_goto_separated_nonempty_list_COMMA_param_decl_ _menhir_env _menhir_stack _menhir_s _v) : 'freshtv340)) : 'freshtv342)
    | _ ->
        _menhir_fail ()

and _menhir_fail : unit -> 'a =
  fun () ->
    Printf.fprintf stderr "Internal failure -- please contact the parser generator's developers.\n%!";
    assert false

and _menhir_goto_separated_nonempty_list_COMMA_expr_ : _menhir_env -> 'ttv_tail -> _menhir_state -> 'tv_separated_nonempty_list_COMMA_expr_ -> 'ttv_return =
  fun _menhir_env _menhir_stack _menhir_s _v ->
    match _menhir_s with
    | MenhirState3 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv329) = Obj.magic _menhir_stack in
        let (_menhir_s : _menhir_state) = _menhir_s in
        let (_v : 'tv_separated_nonempty_list_COMMA_expr_) = _v in
        ((let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv327) = Obj.magic _menhir_stack in
        let (_menhir_s : _menhir_state) = _menhir_s in
        let ((x : 'tv_separated_nonempty_list_COMMA_expr_) : 'tv_separated_nonempty_list_COMMA_expr_) = _v in
        ((let _v : 'tv_loption_separated_nonempty_list_COMMA_expr__ = 
# 144 "<standard.mly>"
    ( x )
# 569 "src/parser.ml"
         in
        _menhir_goto_loption_separated_nonempty_list_COMMA_expr__ _menhir_env _menhir_stack _menhir_s _v) : 'freshtv328)) : 'freshtv330)
    | MenhirState17 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv333 * Lexing.position * _menhir_state * 'tv_expr) * Lexing.position) = Obj.magic _menhir_stack in
        let (_menhir_s : _menhir_state) = _menhir_s in
        let (_v : 'tv_separated_nonempty_list_COMMA_expr_) = _v in
        ((let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv331 * Lexing.position * _menhir_state * 'tv_expr) * Lexing.position) = Obj.magic _menhir_stack in
        let (_ : _menhir_state) = _menhir_s in
        let ((xs : 'tv_separated_nonempty_list_COMMA_expr_) : 'tv_separated_nonempty_list_COMMA_expr_) = _v in
        ((let ((_menhir_stack, _endpos_x_, _menhir_s, (x : 'tv_expr)), _endpos__2_) = _menhir_stack in
        let _2 = () in
        let _v : 'tv_separated_nonempty_list_COMMA_expr_ = 
# 243 "<standard.mly>"
    ( x :: xs )
# 586 "src/parser.ml"
         in
        _menhir_goto_separated_nonempty_list_COMMA_expr_ _menhir_env _menhir_stack _menhir_s _v) : 'freshtv332)) : 'freshtv334)
    | _ ->
        _menhir_fail ()

and _menhir_goto_right_flexible_list_COMMA_expr_ : _menhir_env -> 'ttv_tail -> Lexing.position -> _menhir_state -> 'tv_right_flexible_list_COMMA_expr_ -> 'ttv_return =
  fun _menhir_env _menhir_stack _endpos _menhir_s _v ->
    match _menhir_s with
    | MenhirState72 | MenhirState4 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv321) = Obj.magic _menhir_stack in
        let (_endpos : Lexing.position) = _endpos in
        let (_menhir_s : _menhir_state) = _menhir_s in
        let (_v : 'tv_right_flexible_list_COMMA_expr_) = _v in
        ((let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv319) = Obj.magic _menhir_stack in
        let (_endpos__1_ : Lexing.position) = _endpos in
        let (_menhir_s : _menhir_state) = _menhir_s in
        let ((_1 : 'tv_right_flexible_list_COMMA_expr_) : 'tv_right_flexible_list_COMMA_expr_) = _v in
        ((let _endpos = _endpos__1_ in
        let _v : 'tv_barelist = 
# 173 "src/parser.mly"
                                       ( _1 )
# 610 "src/parser.ml"
         in
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv317) = _menhir_stack in
        let (_endpos : Lexing.position) = _endpos in
        let (_menhir_s : _menhir_state) = _menhir_s in
        let (_v : 'tv_barelist) = _v in
        ((let _menhir_stack = (_menhir_stack, _endpos, _menhir_s, _v) in
        match _menhir_s with
        | MenhirState4 ->
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : ('freshtv305 * Lexing.position * _menhir_state * Lexing.position) * Lexing.position * _menhir_state * 'tv_barelist) = Obj.magic _menhir_stack in
            ((assert (not _menhir_env._menhir_error);
            let _tok = _menhir_env._menhir_token in
            match _tok with
            | RIGHT_ARRAY ->
                let (_menhir_env : _menhir_env) = _menhir_env in
                let (_menhir_stack : ('freshtv301 * Lexing.position * _menhir_state * Lexing.position) * Lexing.position * _menhir_state * 'tv_barelist) = Obj.magic _menhir_stack in
                let (_endpos : Lexing.position) = _menhir_env._menhir_lexbuf.Lexing.lex_curr_p in
                ((let _menhir_env = _menhir_discard _menhir_env in
                let (_menhir_env : _menhir_env) = _menhir_env in
                let (_menhir_stack : ('freshtv299 * Lexing.position * _menhir_state * Lexing.position) * Lexing.position * _menhir_state * 'tv_barelist) = Obj.magic _menhir_stack in
                let (_endpos__3_ : Lexing.position) = _endpos in
                ((let ((_menhir_stack, _endpos__1_, _menhir_s, _startpos__1_), _endpos__2_, _, (_2 : 'tv_barelist)) = _menhir_stack in
                let _3 = () in
                let _1 = () in
                let _endpos = _endpos__3_ in
                let _v : 'tv_expr = let _endpos = _endpos__3_ in
                let _startpos = _startpos__1_ in
                let _loc = (_startpos, _endpos) in
                
# 170 "src/parser.mly"
                                      ( Ast.EList (_loc, _2) )
# 643 "src/parser.ml"
                 in
                _menhir_goto_expr _menhir_env _menhir_stack _endpos _menhir_s _v) : 'freshtv300)) : 'freshtv302)
            | _ ->
                assert (not _menhir_env._menhir_error);
                _menhir_env._menhir_error <- true;
                let (_menhir_env : _menhir_env) = _menhir_env in
                let (_menhir_stack : ('freshtv303 * Lexing.position * _menhir_state * Lexing.position) * Lexing.position * _menhir_state * 'tv_barelist) = Obj.magic _menhir_stack in
                ((let (_menhir_stack, _, _menhir_s, _) = _menhir_stack in
                _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv304)) : 'freshtv306)
        | MenhirState72 ->
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : ((('freshtv315 * 'tv_option_goal_stmt_ * Lexing.position) * _menhir_state * 'tv_patterns) * Lexing.position) * Lexing.position * _menhir_state * 'tv_barelist) = Obj.magic _menhir_stack in
            ((assert (not _menhir_env._menhir_error);
            let _tok = _menhir_env._menhir_token in
            match _tok with
            | CODE _v ->
                let (_menhir_env : _menhir_env) = _menhir_env in
                let (_menhir_stack : 'freshtv309) = Obj.magic _menhir_stack in
                let (_endpos : Lexing.position) = _menhir_env._menhir_lexbuf.Lexing.lex_curr_p in
                let (_v : (
# 63 "src/parser.mly"
       (Ast.code)
# 666 "src/parser.ml"
                )) = _v in
                ((let _menhir_env = _menhir_discard _menhir_env in
                let (_menhir_env : _menhir_env) = _menhir_env in
                let (_menhir_stack : 'freshtv307) = Obj.magic _menhir_stack in
                let (_endpos_x_ : Lexing.position) = _endpos in
                let ((x : (
# 63 "src/parser.mly"
       (Ast.code)
# 675 "src/parser.ml"
                )) : (
# 63 "src/parser.mly"
       (Ast.code)
# 679 "src/parser.ml"
                )) = _v in
                ((let _endpos = _endpos_x_ in
                let _v : 'tv_option_CODE_ = 
# 116 "<standard.mly>"
    ( Some x )
# 685 "src/parser.ml"
                 in
                _menhir_goto_option_CODE_ _menhir_env _menhir_stack _endpos _v) : 'freshtv308)) : 'freshtv310)
            | COLON | EOF | FUNCTION | GOAL | INCLUDE | LET | OPTINCLUDE | PRED _ | PREDICATE | PURE | SEMICOLON | STRING _ ->
                let (_menhir_env : _menhir_env) = _menhir_env in
                let (_menhir_stack : 'freshtv311) = Obj.magic _menhir_stack in
                ((let (_, _endpos) = Obj.magic _menhir_stack in
                let _v : 'tv_option_CODE_ = 
# 114 "<standard.mly>"
    ( None )
# 695 "src/parser.ml"
                 in
                _menhir_goto_option_CODE_ _menhir_env _menhir_stack _endpos _v) : 'freshtv312)
            | _ ->
                assert (not _menhir_env._menhir_error);
                _menhir_env._menhir_error <- true;
                let (_menhir_env : _menhir_env) = _menhir_env in
                let (_menhir_stack : ((('freshtv313 * 'tv_option_goal_stmt_ * Lexing.position) * _menhir_state * 'tv_patterns) * Lexing.position) * Lexing.position * _menhir_state * 'tv_barelist) = Obj.magic _menhir_stack in
                ((let (_menhir_stack, _, _menhir_s, _) = _menhir_stack in
                _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv314)) : 'freshtv316)
        | _ ->
            _menhir_fail ()) : 'freshtv318)) : 'freshtv320)) : 'freshtv322)
    | MenhirState9 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv325 * Lexing.position * _menhir_state * 'tv_expr) * Lexing.position) = Obj.magic _menhir_stack in
        let (_endpos : Lexing.position) = _endpos in
        let (_menhir_s : _menhir_state) = _menhir_s in
        let (_v : 'tv_right_flexible_list_COMMA_expr_) = _v in
        ((let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv323 * Lexing.position * _menhir_state * 'tv_expr) * Lexing.position) = Obj.magic _menhir_stack in
        let (_endpos_xs_ : Lexing.position) = _endpos in
        let (_ : _menhir_state) = _menhir_s in
        let ((xs : 'tv_right_flexible_list_COMMA_expr_) : 'tv_right_flexible_list_COMMA_expr_) = _v in
        ((let ((_menhir_stack, _endpos_x_, _menhir_s, (x : 'tv_expr)), _endpos__2_) = _menhir_stack in
        let _2 = () in
        let _endpos = _endpos_xs_ in
        let _v : 'tv_right_flexible_list_COMMA_expr_ = 
# 190 "src/parser.mly"
                                                     ( x :: xs )
# 724 "src/parser.ml"
         in
        _menhir_goto_right_flexible_list_COMMA_expr_ _menhir_env _menhir_stack _endpos _menhir_s _v) : 'freshtv324)) : 'freshtv326)
    | _ ->
        _menhir_fail ()

and _menhir_goto_loption_separated_nonempty_list_COMMA_expr__ : _menhir_env -> 'ttv_tail -> _menhir_state -> 'tv_loption_separated_nonempty_list_COMMA_expr__ -> 'ttv_return =
  fun _menhir_env _menhir_stack _menhir_s _v ->
    let _menhir_stack = (_menhir_stack, _menhir_s, _v) in
    let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : ('freshtv297 * _menhir_state) * _menhir_state * 'tv_loption_separated_nonempty_list_COMMA_expr__) = Obj.magic _menhir_stack in
    ((assert (not _menhir_env._menhir_error);
    let _tok = _menhir_env._menhir_token in
    match _tok with
    | RIGHT_PAREN ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv293 * _menhir_state) * _menhir_state * 'tv_loption_separated_nonempty_list_COMMA_expr__) = Obj.magic _menhir_stack in
        let (_endpos : Lexing.position) = _menhir_env._menhir_lexbuf.Lexing.lex_curr_p in
        ((let _menhir_env = _menhir_discard _menhir_env in
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv291 * _menhir_state) * _menhir_state * 'tv_loption_separated_nonempty_list_COMMA_expr__) = Obj.magic _menhir_stack in
        let (_endpos__3_ : Lexing.position) = _endpos in
        ((let ((_menhir_stack, _menhir_s), _, (xs : 'tv_loption_separated_nonempty_list_COMMA_expr__)) = _menhir_stack in
        let _3 = () in
        let _1 = () in
        let _endpos = _endpos__3_ in
        let _v : 'tv_params = let _2 = 
# 232 "<standard.mly>"
    ( xs )
# 753 "src/parser.ml"
         in
        
# 176 "src/parser.mly"
                                                         ( _2 )
# 758 "src/parser.ml"
         in
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv289) = _menhir_stack in
        let (_endpos : Lexing.position) = _endpos in
        let (_menhir_s : _menhir_state) = _menhir_s in
        let (_v : 'tv_params) = _v in
        ((match _menhir_s with
        | MenhirState5 ->
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv283 * Lexing.position * _menhir_state * (
# 71 "src/parser.mly"
       (string)
# 771 "src/parser.ml"
            ) * Lexing.position) = Obj.magic _menhir_stack in
            let (_endpos : Lexing.position) = _endpos in
            let (_menhir_s : _menhir_state) = _menhir_s in
            let (_v : 'tv_params) = _v in
            ((let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv281 * Lexing.position * _menhir_state * (
# 71 "src/parser.mly"
       (string)
# 780 "src/parser.ml"
            ) * Lexing.position) = Obj.magic _menhir_stack in
            let (_endpos__2_ : Lexing.position) = _endpos in
            let (_ : _menhir_state) = _menhir_s in
            let ((_2 : 'tv_params) : 'tv_params) = _v in
            ((let (_menhir_stack, _endpos__1_, _menhir_s, (_1 : (
# 71 "src/parser.mly"
       (string)
# 788 "src/parser.ml"
            )), _startpos__1_) = _menhir_stack in
            let _endpos = _endpos__2_ in
            let _v : 'tv_expr = let _endpos = _endpos__2_ in
            let _startpos = _startpos__1_ in
            let _loc = (_startpos, _endpos) in
            
# 166 "src/parser.mly"
                 ( Ast.ECall (_loc, _1, _2) )
# 797 "src/parser.ml"
             in
            _menhir_goto_expr _menhir_env _menhir_stack _endpos _menhir_s _v) : 'freshtv282)) : 'freshtv284)
        | MenhirState2 ->
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv287 * _menhir_state * (
# 85 "src/parser.mly"
       (string)
# 805 "src/parser.ml"
            ) * Lexing.position) = Obj.magic _menhir_stack in
            let (_endpos : Lexing.position) = _endpos in
            let (_menhir_s : _menhir_state) = _menhir_s in
            let (_v : 'tv_params) = _v in
            ((let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv285 * _menhir_state * (
# 85 "src/parser.mly"
       (string)
# 814 "src/parser.ml"
            ) * Lexing.position) = Obj.magic _menhir_stack in
            let (_endpos__2_ : Lexing.position) = _endpos in
            let (_ : _menhir_state) = _menhir_s in
            let ((_2 : 'tv_params) : 'tv_params) = _v in
            ((let (_menhir_stack, _menhir_s, (_1 : (
# 85 "src/parser.mly"
       (string)
# 822 "src/parser.ml"
            )), _startpos__1_) = _menhir_stack in
            let _endpos = _endpos__2_ in
            let _v : 'tv_expr = let _endpos = _endpos__2_ in
            let _startpos = _startpos__1_ in
            let _loc = (_startpos, _endpos) in
            
# 168 "src/parser.mly"
                  ( Ast.EPredCtor (_loc, _1, _2) )
# 831 "src/parser.ml"
             in
            _menhir_goto_expr _menhir_env _menhir_stack _endpos _menhir_s _v) : 'freshtv286)) : 'freshtv288)
        | _ ->
            _menhir_fail ()) : 'freshtv290)) : 'freshtv292)) : 'freshtv294)
    | _ ->
        assert (not _menhir_env._menhir_error);
        _menhir_env._menhir_error <- true;
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv295 * _menhir_state) * _menhir_state * 'tv_loption_separated_nonempty_list_COMMA_expr__) = Obj.magic _menhir_stack in
        ((let (_menhir_stack, _menhir_s, _) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv296)) : 'freshtv298)

and _menhir_goto_loption_separated_nonempty_list_COMMA_pattern__ : _menhir_env -> 'ttv_tail -> _menhir_state -> 'tv_loption_separated_nonempty_list_COMMA_pattern__ -> 'ttv_return =
  fun _menhir_env _menhir_stack _menhir_s _v ->
    let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : 'freshtv279) = Obj.magic _menhir_stack in
    let (_menhir_s : _menhir_state) = _menhir_s in
    let (_v : 'tv_loption_separated_nonempty_list_COMMA_pattern__) = _v in
    ((let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : 'freshtv277) = Obj.magic _menhir_stack in
    let (_menhir_s : _menhir_state) = _menhir_s in
    let ((xs : 'tv_loption_separated_nonempty_list_COMMA_pattern__) : 'tv_loption_separated_nonempty_list_COMMA_pattern__) = _v in
    ((let _v : 'tv_patterns = let _1 = 
# 232 "<standard.mly>"
    ( xs )
# 857 "src/parser.ml"
     in
    
# 152 "src/parser.mly"
                                     ( _1 )
# 862 "src/parser.ml"
     in
    let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : 'freshtv275) = _menhir_stack in
    let (_menhir_s : _menhir_state) = _menhir_s in
    let (_v : 'tv_patterns) = _v in
    ((let _menhir_stack = (_menhir_stack, _menhir_s, _v) in
    let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : ('freshtv273 * 'tv_option_goal_stmt_ * Lexing.position) * _menhir_state * 'tv_patterns) = Obj.magic _menhir_stack in
    ((assert (not _menhir_env._menhir_error);
    let _tok = _menhir_env._menhir_token in
    match _tok with
    | COLON ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv269 * 'tv_option_goal_stmt_ * Lexing.position) * _menhir_state * 'tv_patterns) = Obj.magic _menhir_stack in
        let (_endpos : Lexing.position) = _menhir_env._menhir_lexbuf.Lexing.lex_curr_p in
        ((let _menhir_stack = (_menhir_stack, _endpos) in
        let _menhir_env = _menhir_discard _menhir_env in
        let _tok = _menhir_env._menhir_token in
        match _tok with
        | ID _v ->
            _menhir_run5 _menhir_env (Obj.magic _menhir_stack) _menhir_env._menhir_lexbuf.Lexing.lex_curr_p MenhirState72 _v _menhir_env._menhir_lexbuf.Lexing.lex_start_p
        | LEFT_ARRAY ->
            _menhir_run4 _menhir_env (Obj.magic _menhir_stack) _menhir_env._menhir_lexbuf.Lexing.lex_curr_p MenhirState72 _menhir_env._menhir_lexbuf.Lexing.lex_start_p
        | PRED _v ->
            _menhir_run2 _menhir_env (Obj.magic _menhir_stack) MenhirState72 _v _menhir_env._menhir_lexbuf.Lexing.lex_start_p
        | STRING _v ->
            _menhir_run1 _menhir_env (Obj.magic _menhir_stack) _menhir_env._menhir_lexbuf.Lexing.lex_curr_p MenhirState72 _v _menhir_env._menhir_lexbuf.Lexing.lex_start_p
        | CODE _ | COLON | EOF | FUNCTION | GOAL | INCLUDE | LET | OPTINCLUDE | PREDICATE | PURE | SEMICOLON ->
            _menhir_reduce41 _menhir_env (Obj.magic _menhir_stack) MenhirState72
        | _ ->
            assert (not _menhir_env._menhir_error);
            _menhir_env._menhir_error <- true;
            _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState72) : 'freshtv270)
    | _ ->
        assert (not _menhir_env._menhir_error);
        _menhir_env._menhir_error <- true;
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv271 * 'tv_option_goal_stmt_ * Lexing.position) * _menhir_state * 'tv_patterns) = Obj.magic _menhir_stack in
        ((let (_menhir_stack, _menhir_s, _) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv272)) : 'freshtv274)) : 'freshtv276)) : 'freshtv278)) : 'freshtv280)

and _menhir_run59 : _menhir_env -> 'ttv_tail -> Lexing.position -> _menhir_state -> (
# 82 "src/parser.mly"
       (Ast.substs)
# 907 "src/parser.ml"
) -> Lexing.position -> 'ttv_return =
  fun _menhir_env _menhir_stack _endpos _menhir_s _v _startpos ->
    let _menhir_env = _menhir_discard _menhir_env in
    let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : 'freshtv267) = Obj.magic _menhir_stack in
    let (_endpos__1_ : Lexing.position) = _endpos in
    let (_menhir_s : _menhir_state) = _menhir_s in
    let ((_1 : (
# 82 "src/parser.mly"
       (Ast.substs)
# 918 "src/parser.ml"
    )) : (
# 82 "src/parser.mly"
       (Ast.substs)
# 922 "src/parser.ml"
    )) = _v in
    let (_startpos__1_ : Lexing.position) = _startpos in
    ((let _v : 'tv_pattern = let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    
# 155 "src/parser.mly"
                 ( Ast.PPred (_loc, "is-file", [_1]) )
# 931 "src/parser.ml"
     in
    _menhir_goto_pattern _menhir_env _menhir_stack _menhir_s _v) : 'freshtv268)

and _menhir_run60 : _menhir_env -> 'ttv_tail -> _menhir_state -> (
# 85 "src/parser.mly"
       (string)
# 938 "src/parser.ml"
) -> Lexing.position -> 'ttv_return =
  fun _menhir_env _menhir_stack _menhir_s _v _startpos ->
    let _menhir_stack = (_menhir_stack, _menhir_s, _v, _startpos) in
    let _menhir_env = _menhir_discard _menhir_env in
    let _tok = _menhir_env._menhir_token in
    match _tok with
    | LEFT_PAREN ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv263) = Obj.magic _menhir_stack in
        ((let _menhir_env = _menhir_discard _menhir_env in
        let _tok = _menhir_env._menhir_token in
        match _tok with
        | STRING _v ->
            _menhir_run62 _menhir_env (Obj.magic _menhir_stack) _menhir_env._menhir_lexbuf.Lexing.lex_curr_p MenhirState61 _v _menhir_env._menhir_lexbuf.Lexing.lex_start_p
        | RIGHT_PAREN ->
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv261) = Obj.magic _menhir_stack in
            let (_menhir_s : _menhir_state) = MenhirState61 in
            ((let _v : 'tv_loption_separated_nonempty_list_COMMA_pattern_param__ = 
# 142 "<standard.mly>"
    ( [] )
# 960 "src/parser.ml"
             in
            _menhir_goto_loption_separated_nonempty_list_COMMA_pattern_param__ _menhir_env _menhir_stack _menhir_s _v) : 'freshtv262)
        | _ ->
            assert (not _menhir_env._menhir_error);
            _menhir_env._menhir_error <- true;
            _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState61) : 'freshtv264)
    | _ ->
        assert (not _menhir_env._menhir_error);
        _menhir_env._menhir_error <- true;
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv265 * _menhir_state * (
# 85 "src/parser.mly"
       (string)
# 974 "src/parser.ml"
        ) * Lexing.position) = Obj.magic _menhir_stack in
        ((let (_menhir_stack, _menhir_s, _, _) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv266)

and _menhir_goto_option_SEMICOLON_ : _menhir_env -> 'ttv_tail -> Lexing.position -> _menhir_state -> 'tv_option_SEMICOLON_ -> 'ttv_return =
  fun _menhir_env _menhir_stack _endpos _menhir_s _v ->
    match _menhir_s with
    | MenhirState40 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : (('freshtv251 * Lexing.position * 'tv_stmts * Lexing.position)) * Lexing.position * (
# 82 "src/parser.mly"
       (Ast.substs)
# 987 "src/parser.ml"
        ) * Lexing.position) = Obj.magic _menhir_stack in
        let (_endpos : Lexing.position) = _endpos in
        let (_menhir_s : _menhir_state) = _menhir_s in
        let (_v : 'tv_option_SEMICOLON_) = _v in
        ((let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : (('freshtv249 * Lexing.position * 'tv_stmts * Lexing.position)) * Lexing.position * (
# 82 "src/parser.mly"
       (Ast.substs)
# 996 "src/parser.ml"
        ) * Lexing.position) = Obj.magic _menhir_stack in
        let (_endpos__4_ : Lexing.position) = _endpos in
        let (_ : _menhir_state) = _menhir_s in
        let ((_4 : 'tv_option_SEMICOLON_) : 'tv_option_SEMICOLON_) = _v in
        ((let ((_menhir_stack, _endpos__1_, (_1 : 'tv_stmts), _startpos__1_), _endpos__3_, (_3 : (
# 82 "src/parser.mly"
       (Ast.substs)
# 1004 "src/parser.ml"
        )), _startpos__3_) = _menhir_stack in
        let _2 = () in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v : 'tv_stmts = let _endpos = _endpos__4_ in
        let _startpos = _startpos__1_ in
        let _loc = (_startpos, _endpos) in
        
# 102 "src/parser.mly"
    ( do_include _1 _loc _3 true file )
# 1015 "src/parser.ml"
         in
        _menhir_goto_stmts _menhir_env _menhir_stack _endpos _v _startpos) : 'freshtv250)) : 'freshtv252)
    | MenhirState48 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : (('freshtv255 * Lexing.position * 'tv_stmts * Lexing.position)) * Lexing.position * (
# 82 "src/parser.mly"
       (Ast.substs)
# 1023 "src/parser.ml"
        ) * Lexing.position) = Obj.magic _menhir_stack in
        let (_endpos : Lexing.position) = _endpos in
        let (_menhir_s : _menhir_state) = _menhir_s in
        let (_v : 'tv_option_SEMICOLON_) = _v in
        ((let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : (('freshtv253 * Lexing.position * 'tv_stmts * Lexing.position)) * Lexing.position * (
# 82 "src/parser.mly"
       (Ast.substs)
# 1032 "src/parser.ml"
        ) * Lexing.position) = Obj.magic _menhir_stack in
        let (_endpos__4_ : Lexing.position) = _endpos in
        let (_ : _menhir_state) = _menhir_s in
        let ((_4 : 'tv_option_SEMICOLON_) : 'tv_option_SEMICOLON_) = _v in
        ((let ((_menhir_stack, _endpos__1_, (_1 : 'tv_stmts), _startpos__1_), _endpos__3_, (_3 : (
# 82 "src/parser.mly"
       (Ast.substs)
# 1040 "src/parser.ml"
        )), _startpos__3_) = _menhir_stack in
        let _2 = () in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v : 'tv_stmts = let _endpos = _endpos__4_ in
        let _startpos = _startpos__1_ in
        let _loc = (_startpos, _endpos) in
        
# 100 "src/parser.mly"
    ( do_include _1 _loc _3 false file )
# 1051 "src/parser.ml"
         in
        _menhir_goto_stmts _menhir_env _menhir_stack _endpos _v _startpos) : 'freshtv254)) : 'freshtv256)
    | MenhirState56 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv259 * Lexing.position * 'tv_stmts * Lexing.position) * Lexing.position * 'tv_stmt) = Obj.magic _menhir_stack in
        let (_endpos : Lexing.position) = _endpos in
        let (_menhir_s : _menhir_state) = _menhir_s in
        let (_v : 'tv_option_SEMICOLON_) = _v in
        ((let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv257 * Lexing.position * 'tv_stmts * Lexing.position) * Lexing.position * 'tv_stmt) = Obj.magic _menhir_stack in
        let (_endpos__3_ : Lexing.position) = _endpos in
        let (_ : _menhir_state) = _menhir_s in
        let ((_3 : 'tv_option_SEMICOLON_) : 'tv_option_SEMICOLON_) = _v in
        ((let ((_menhir_stack, _endpos__1_, (_1 : 'tv_stmts), _startpos__1_), _endpos__2_, (_2 : 'tv_stmt)) = _menhir_stack in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v : 'tv_stmts = 
# 104 "src/parser.mly"
    ( let name, expr = _2 in Ast.Env.add name expr _1 )
# 1071 "src/parser.ml"
         in
        _menhir_goto_stmts _menhir_env _menhir_stack _endpos _v _startpos) : 'freshtv258)) : 'freshtv260)
    | _ ->
        _menhir_fail ()

and _menhir_goto_loption_separated_nonempty_list_COMMA_param_decl__ : _menhir_env -> 'ttv_tail -> _menhir_state -> 'tv_loption_separated_nonempty_list_COMMA_param_decl__ -> 'ttv_return =
  fun _menhir_env _menhir_stack _menhir_s _v ->
    let _menhir_stack = (_menhir_stack, _menhir_s, _v) in
    let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : ('freshtv247 * _menhir_state) * _menhir_state * 'tv_loption_separated_nonempty_list_COMMA_param_decl__) = Obj.magic _menhir_stack in
    ((assert (not _menhir_env._menhir_error);
    let _tok = _menhir_env._menhir_token in
    match _tok with
    | RIGHT_PAREN ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv243 * _menhir_state) * _menhir_state * 'tv_loption_separated_nonempty_list_COMMA_param_decl__) = Obj.magic _menhir_stack in
        let (_endpos : Lexing.position) = _menhir_env._menhir_lexbuf.Lexing.lex_curr_p in
        ((let _menhir_env = _menhir_discard _menhir_env in
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv241 * _menhir_state) * _menhir_state * 'tv_loption_separated_nonempty_list_COMMA_param_decl__) = Obj.magic _menhir_stack in
        let (_endpos__3_ : Lexing.position) = _endpos in
        ((let ((_menhir_stack, _menhir_s), _, (xs : 'tv_loption_separated_nonempty_list_COMMA_param_decl__)) = _menhir_stack in
        let _3 = () in
        let _1 = () in
        let _v : 'tv_params_decl = let _2 = 
# 232 "<standard.mly>"
    ( xs )
# 1099 "src/parser.ml"
         in
        
# 141 "src/parser.mly"
                                                               ( _2 )
# 1104 "src/parser.ml"
         in
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv239) = _menhir_stack in
        let (_menhir_s : _menhir_state) = _menhir_s in
        let (_v : 'tv_params_decl) = _v in
        ((let _menhir_stack = (_menhir_stack, _menhir_s, _v) in
        match _menhir_s with
        | MenhirState27 ->
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : (('freshtv211 * Lexing.position) * (
# 85 "src/parser.mly"
       (string)
# 1117 "src/parser.ml"
            ) * Lexing.position) * _menhir_state * 'tv_params_decl) = Obj.magic _menhir_stack in
            ((assert (not _menhir_env._menhir_error);
            let _tok = _menhir_env._menhir_token in
            match _tok with
            | EQUALS ->
                let (_menhir_env : _menhir_env) = _menhir_env in
                let (_menhir_stack : (('freshtv207 * Lexing.position) * (
# 85 "src/parser.mly"
       (string)
# 1127 "src/parser.ml"
                ) * Lexing.position) * _menhir_state * 'tv_params_decl) = Obj.magic _menhir_stack in
                ((let _menhir_env = _menhir_discard _menhir_env in
                let _tok = _menhir_env._menhir_token in
                match _tok with
                | CODE _v ->
                    let (_menhir_env : _menhir_env) = _menhir_env in
                    let (_menhir_stack : ((('freshtv203 * Lexing.position) * (
# 85 "src/parser.mly"
       (string)
# 1137 "src/parser.ml"
                    ) * Lexing.position) * _menhir_state * 'tv_params_decl)) = Obj.magic _menhir_stack in
                    let (_endpos : Lexing.position) = _menhir_env._menhir_lexbuf.Lexing.lex_curr_p in
                    let (_v : (
# 63 "src/parser.mly"
       (Ast.code)
# 1143 "src/parser.ml"
                    )) = _v in
                    ((let _menhir_env = _menhir_discard _menhir_env in
                    let (_menhir_env : _menhir_env) = _menhir_env in
                    let (_menhir_stack : ((('freshtv201 * Lexing.position) * (
# 85 "src/parser.mly"
       (string)
# 1150 "src/parser.ml"
                    ) * Lexing.position) * _menhir_state * 'tv_params_decl)) = Obj.magic _menhir_stack in
                    let (_endpos__5_ : Lexing.position) = _endpos in
                    let ((_5 : (
# 63 "src/parser.mly"
       (Ast.code)
# 1156 "src/parser.ml"
                    )) : (
# 63 "src/parser.mly"
       (Ast.code)
# 1160 "src/parser.ml"
                    )) = _v in
                    ((let (((_menhir_stack, _startpos__1_), (_2 : (
# 85 "src/parser.mly"
       (string)
# 1165 "src/parser.ml"
                    )), _startpos__2_), _, (_3 : 'tv_params_decl)) = _menhir_stack in
                    let _4 = () in
                    let _1 = () in
                    let _endpos = _endpos__5_ in
                    let _v : 'tv_stmt = let _endpos = _endpos__5_ in
                    let _startpos = _startpos__1_ in
                    let _loc = (_startpos, _endpos) in
                    
# 130 "src/parser.mly"
    (
      _2, Ast.EPredDefn (_loc, (_3, _5))
    )
# 1178 "src/parser.ml"
                     in
                    _menhir_goto_stmt _menhir_env _menhir_stack _endpos _v) : 'freshtv202)) : 'freshtv204)
                | _ ->
                    assert (not _menhir_env._menhir_error);
                    _menhir_env._menhir_error <- true;
                    let (_menhir_env : _menhir_env) = _menhir_env in
                    let (_menhir_stack : ((('freshtv205 * Lexing.position) * (
# 85 "src/parser.mly"
       (string)
# 1188 "src/parser.ml"
                    ) * Lexing.position) * _menhir_state * 'tv_params_decl)) = Obj.magic _menhir_stack in
                    ((let (_menhir_stack, _menhir_s, _) = _menhir_stack in
                    _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv206)) : 'freshtv208)
            | _ ->
                assert (not _menhir_env._menhir_error);
                _menhir_env._menhir_error <- true;
                let (_menhir_env : _menhir_env) = _menhir_env in
                let (_menhir_stack : (('freshtv209 * Lexing.position) * (
# 85 "src/parser.mly"
       (string)
# 1199 "src/parser.ml"
                ) * Lexing.position) * _menhir_state * 'tv_params_decl) = Obj.magic _menhir_stack in
                ((let (_menhir_stack, _menhir_s, _) = _menhir_stack in
                _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv210)) : 'freshtv212)
        | MenhirState51 ->
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv215 * _menhir_state * 'tv_params_decl) = Obj.magic _menhir_stack in
            ((let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv213 * _menhir_state * 'tv_params_decl) = Obj.magic _menhir_stack in
            ((let (_menhir_stack, _menhir_s, (x : 'tv_params_decl)) = _menhir_stack in
            let _v : 'tv_option_params_decl_ = 
# 116 "<standard.mly>"
    ( Some x )
# 1212 "src/parser.ml"
             in
            _menhir_goto_option_params_decl_ _menhir_env _menhir_stack _menhir_s _v) : 'freshtv214)) : 'freshtv216)
        | MenhirState82 ->
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : ((('freshtv237 * 'tv_option_PURE_ * Lexing.position)) * Lexing.position * (
# 71 "src/parser.mly"
       (string)
# 1220 "src/parser.ml"
            ) * Lexing.position) * _menhir_state * 'tv_params_decl) = Obj.magic _menhir_stack in
            ((assert (not _menhir_env._menhir_error);
            let _tok = _menhir_env._menhir_token in
            match _tok with
            | RETURNING ->
                let (_menhir_env : _menhir_env) = _menhir_env in
                let (_menhir_stack : 'freshtv231) = Obj.magic _menhir_stack in
                ((let _menhir_env = _menhir_discard _menhir_env in
                let _tok = _menhir_env._menhir_token in
                match _tok with
                | EXPRESSION ->
                    let (_menhir_env : _menhir_env) = _menhir_env in
                    let (_menhir_stack : 'freshtv219) = Obj.magic _menhir_stack in
                    ((let _menhir_env = _menhir_discard _menhir_env in
                    let (_menhir_env : _menhir_env) = _menhir_env in
                    let (_menhir_stack : 'freshtv217) = Obj.magic _menhir_stack in
                    ((let _2 = () in
                    let _1 = () in
                    let _v : 'tv_return_decl = 
# 147 "src/parser.mly"
                           ( RetExpr )
# 1242 "src/parser.ml"
                     in
                    _menhir_goto_return_decl _menhir_env _menhir_stack _v) : 'freshtv218)) : 'freshtv220)
                | STRINGS ->
                    let (_menhir_env : _menhir_env) = _menhir_env in
                    let (_menhir_stack : 'freshtv223) = Obj.magic _menhir_stack in
                    ((let _menhir_env = _menhir_discard _menhir_env in
                    let (_menhir_env : _menhir_env) = _menhir_env in
                    let (_menhir_stack : 'freshtv221) = Obj.magic _menhir_stack in
                    ((let _2 = () in
                    let _1 = () in
                    let _v : 'tv_return_decl = 
# 148 "src/parser.mly"
                        ( RetStrings )
# 1256 "src/parser.ml"
                     in
                    _menhir_goto_return_decl _menhir_env _menhir_stack _v) : 'freshtv222)) : 'freshtv224)
                | STRING_KEYWORD ->
                    let (_menhir_env : _menhir_env) = _menhir_env in
                    let (_menhir_stack : 'freshtv227) = Obj.magic _menhir_stack in
                    ((let _menhir_env = _menhir_discard _menhir_env in
                    let (_menhir_env : _menhir_env) = _menhir_env in
                    let (_menhir_stack : 'freshtv225) = Obj.magic _menhir_stack in
                    ((let _2 = () in
                    let _1 = () in
                    let _v : 'tv_return_decl = 
# 149 "src/parser.mly"
                               ( RetString )
# 1270 "src/parser.ml"
                     in
                    _menhir_goto_return_decl _menhir_env _menhir_stack _v) : 'freshtv226)) : 'freshtv228)
                | _ ->
                    assert (not _menhir_env._menhir_error);
                    _menhir_env._menhir_error <- true;
                    let (_menhir_env : _menhir_env) = _menhir_env in
                    let (_menhir_stack : 'freshtv229) = Obj.magic _menhir_stack in
                    (raise _eRR : 'freshtv230)) : 'freshtv232)
            | EQUALS ->
                let (_menhir_env : _menhir_env) = _menhir_env in
                let (_menhir_stack : 'freshtv233) = Obj.magic _menhir_stack in
                ((let _v : 'tv_return_decl = 
# 146 "src/parser.mly"
                 ( RetExpr )
# 1285 "src/parser.ml"
                 in
                _menhir_goto_return_decl _menhir_env _menhir_stack _v) : 'freshtv234)
            | _ ->
                assert (not _menhir_env._menhir_error);
                _menhir_env._menhir_error <- true;
                let (_menhir_env : _menhir_env) = _menhir_env in
                let (_menhir_stack : ((('freshtv235 * 'tv_option_PURE_ * Lexing.position)) * Lexing.position * (
# 71 "src/parser.mly"
       (string)
# 1295 "src/parser.ml"
                ) * Lexing.position) * _menhir_state * 'tv_params_decl) = Obj.magic _menhir_stack in
                ((let (_menhir_stack, _menhir_s, _) = _menhir_stack in
                _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv236)) : 'freshtv238)
        | _ ->
            _menhir_fail ()) : 'freshtv240)) : 'freshtv242)) : 'freshtv244)
    | _ ->
        assert (not _menhir_env._menhir_error);
        _menhir_env._menhir_error <- true;
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv245 * _menhir_state) * _menhir_state * 'tv_loption_separated_nonempty_list_COMMA_param_decl__) = Obj.magic _menhir_stack in
        ((let (_menhir_stack, _menhir_s, _) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv246)) : 'freshtv248)

and _menhir_run29 : _menhir_env -> 'ttv_tail -> Lexing.position -> _menhir_state -> (
# 71 "src/parser.mly"
       (string)
# 1312 "src/parser.ml"
) -> Lexing.position -> 'ttv_return =
  fun _menhir_env _menhir_stack _endpos _menhir_s _v _startpos ->
    let _menhir_env = _menhir_discard _menhir_env in
    let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : 'freshtv199) = Obj.magic _menhir_stack in
    let (_endpos__1_ : Lexing.position) = _endpos in
    let (_menhir_s : _menhir_state) = _menhir_s in
    let ((_1 : (
# 71 "src/parser.mly"
       (string)
# 1323 "src/parser.ml"
    )) : (
# 71 "src/parser.mly"
       (string)
# 1327 "src/parser.ml"
    )) = _v in
    let (_startpos__1_ : Lexing.position) = _startpos in
    ((let _v : 'tv_param_decl = 
# 144 "src/parser.mly"
                 ( _1 )
# 1333 "src/parser.ml"
     in
    let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : 'freshtv197) = _menhir_stack in
    let (_menhir_s : _menhir_state) = _menhir_s in
    let (_v : 'tv_param_decl) = _v in
    ((let _menhir_stack = (_menhir_stack, _menhir_s, _v) in
    let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : 'freshtv195 * _menhir_state * 'tv_param_decl) = Obj.magic _menhir_stack in
    ((assert (not _menhir_env._menhir_error);
    let _tok = _menhir_env._menhir_token in
    match _tok with
    | COMMA ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv189 * _menhir_state * 'tv_param_decl) = Obj.magic _menhir_stack in
        let (_endpos : Lexing.position) = _menhir_env._menhir_lexbuf.Lexing.lex_curr_p in
        ((let _menhir_stack = (_menhir_stack, _endpos) in
        let _menhir_env = _menhir_discard _menhir_env in
        let _tok = _menhir_env._menhir_token in
        match _tok with
        | ID _v ->
            _menhir_run29 _menhir_env (Obj.magic _menhir_stack) _menhir_env._menhir_lexbuf.Lexing.lex_curr_p MenhirState32 _v _menhir_env._menhir_lexbuf.Lexing.lex_start_p
        | _ ->
            assert (not _menhir_env._menhir_error);
            _menhir_env._menhir_error <- true;
            _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState32) : 'freshtv190)
    | RIGHT_PAREN ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv191 * _menhir_state * 'tv_param_decl) = Obj.magic _menhir_stack in
        ((let (_menhir_stack, _menhir_s, (x : 'tv_param_decl)) = _menhir_stack in
        let _v : 'tv_separated_nonempty_list_COMMA_param_decl_ = 
# 241 "<standard.mly>"
    ( [ x ] )
# 1366 "src/parser.ml"
         in
        _menhir_goto_separated_nonempty_list_COMMA_param_decl_ _menhir_env _menhir_stack _menhir_s _v) : 'freshtv192)
    | _ ->
        assert (not _menhir_env._menhir_error);
        _menhir_env._menhir_error <- true;
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv193 * _menhir_state * 'tv_param_decl) = Obj.magic _menhir_stack in
        ((let (_menhir_stack, _menhir_s, _) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv194)) : 'freshtv196)) : 'freshtv198)) : 'freshtv200)

and _menhir_reduce41 : _menhir_env -> 'ttv_tail -> _menhir_state -> 'ttv_return =
  fun _menhir_env _menhir_stack _menhir_s ->
    let (_, _endpos) = Obj.magic _menhir_stack in
    let _v : 'tv_right_flexible_list_COMMA_expr_ = 
# 188 "src/parser.mly"
                    ( [] )
# 1383 "src/parser.ml"
     in
    _menhir_goto_right_flexible_list_COMMA_expr_ _menhir_env _menhir_stack _endpos _menhir_s _v

and _menhir_goto_expr : _menhir_env -> 'ttv_tail -> Lexing.position -> _menhir_state -> 'tv_expr -> 'ttv_return =
  fun _menhir_env _menhir_stack _endpos _menhir_s _v ->
    let _menhir_stack = (_menhir_stack, _endpos, _menhir_s, _v) in
    match _menhir_s with
    | MenhirState72 | MenhirState9 | MenhirState4 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv161 * Lexing.position * _menhir_state * 'tv_expr) = Obj.magic _menhir_stack in
        ((assert (not _menhir_env._menhir_error);
        let _tok = _menhir_env._menhir_token in
        match _tok with
        | COMMA ->
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv155 * Lexing.position * _menhir_state * 'tv_expr) = Obj.magic _menhir_stack in
            let (_endpos : Lexing.position) = _menhir_env._menhir_lexbuf.Lexing.lex_curr_p in
            ((let _menhir_stack = (_menhir_stack, _endpos) in
            let _menhir_env = _menhir_discard _menhir_env in
            let _tok = _menhir_env._menhir_token in
            match _tok with
            | ID _v ->
                _menhir_run5 _menhir_env (Obj.magic _menhir_stack) _menhir_env._menhir_lexbuf.Lexing.lex_curr_p MenhirState9 _v _menhir_env._menhir_lexbuf.Lexing.lex_start_p
            | LEFT_ARRAY ->
                _menhir_run4 _menhir_env (Obj.magic _menhir_stack) _menhir_env._menhir_lexbuf.Lexing.lex_curr_p MenhirState9 _menhir_env._menhir_lexbuf.Lexing.lex_start_p
            | PRED _v ->
                _menhir_run2 _menhir_env (Obj.magic _menhir_stack) MenhirState9 _v _menhir_env._menhir_lexbuf.Lexing.lex_start_p
            | STRING _v ->
                _menhir_run1 _menhir_env (Obj.magic _menhir_stack) _menhir_env._menhir_lexbuf.Lexing.lex_curr_p MenhirState9 _v _menhir_env._menhir_lexbuf.Lexing.lex_start_p
            | CODE _ | COLON | EOF | FUNCTION | GOAL | INCLUDE | LET | OPTINCLUDE | PREDICATE | PURE | RIGHT_ARRAY | SEMICOLON ->
                _menhir_reduce41 _menhir_env (Obj.magic _menhir_stack) MenhirState9
            | _ ->
                assert (not _menhir_env._menhir_error);
                _menhir_env._menhir_error <- true;
                _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState9) : 'freshtv156)
        | CODE _ | COLON | EOF | FUNCTION | GOAL | INCLUDE | LET | OPTINCLUDE | PRED _ | PREDICATE | PURE | RIGHT_ARRAY | SEMICOLON | STRING _ ->
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv157 * Lexing.position * _menhir_state * 'tv_expr) = Obj.magic _menhir_stack in
            ((let (_menhir_stack, _endpos_x_, _menhir_s, (x : 'tv_expr)) = _menhir_stack in
            let _endpos = _endpos_x_ in
            let _v : 'tv_right_flexible_list_COMMA_expr_ = 
# 189 "src/parser.mly"
            ( [x] )
# 1427 "src/parser.ml"
             in
            _menhir_goto_right_flexible_list_COMMA_expr_ _menhir_env _menhir_stack _endpos _menhir_s _v) : 'freshtv158)
        | _ ->
            assert (not _menhir_env._menhir_error);
            _menhir_env._menhir_error <- true;
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv159 * Lexing.position * _menhir_state * 'tv_expr) = Obj.magic _menhir_stack in
            ((let (_menhir_stack, _, _menhir_s, _) = _menhir_stack in
            _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv160)) : 'freshtv162)
    | MenhirState17 | MenhirState3 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv169 * Lexing.position * _menhir_state * 'tv_expr) = Obj.magic _menhir_stack in
        ((assert (not _menhir_env._menhir_error);
        let _tok = _menhir_env._menhir_token in
        match _tok with
        | COMMA ->
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv163 * Lexing.position * _menhir_state * 'tv_expr) = Obj.magic _menhir_stack in
            let (_endpos : Lexing.position) = _menhir_env._menhir_lexbuf.Lexing.lex_curr_p in
            ((let _menhir_stack = (_menhir_stack, _endpos) in
            let _menhir_env = _menhir_discard _menhir_env in
            let _tok = _menhir_env._menhir_token in
            match _tok with
            | ID _v ->
                _menhir_run5 _menhir_env (Obj.magic _menhir_stack) _menhir_env._menhir_lexbuf.Lexing.lex_curr_p MenhirState17 _v _menhir_env._menhir_lexbuf.Lexing.lex_start_p
            | LEFT_ARRAY ->
                _menhir_run4 _menhir_env (Obj.magic _menhir_stack) _menhir_env._menhir_lexbuf.Lexing.lex_curr_p MenhirState17 _menhir_env._menhir_lexbuf.Lexing.lex_start_p
            | PRED _v ->
                _menhir_run2 _menhir_env (Obj.magic _menhir_stack) MenhirState17 _v _menhir_env._menhir_lexbuf.Lexing.lex_start_p
            | STRING _v ->
                _menhir_run1 _menhir_env (Obj.magic _menhir_stack) _menhir_env._menhir_lexbuf.Lexing.lex_curr_p MenhirState17 _v _menhir_env._menhir_lexbuf.Lexing.lex_start_p
            | _ ->
                assert (not _menhir_env._menhir_error);
                _menhir_env._menhir_error <- true;
                _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState17) : 'freshtv164)
        | RIGHT_PAREN ->
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv165 * Lexing.position * _menhir_state * 'tv_expr) = Obj.magic _menhir_stack in
            ((let (_menhir_stack, _endpos_x_, _menhir_s, (x : 'tv_expr)) = _menhir_stack in
            let _v : 'tv_separated_nonempty_list_COMMA_expr_ = 
# 241 "<standard.mly>"
    ( [ x ] )
# 1470 "src/parser.ml"
             in
            _menhir_goto_separated_nonempty_list_COMMA_expr_ _menhir_env _menhir_stack _menhir_s _v) : 'freshtv166)
        | _ ->
            assert (not _menhir_env._menhir_error);
            _menhir_env._menhir_error <- true;
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv167 * Lexing.position * _menhir_state * 'tv_expr) = Obj.magic _menhir_stack in
            ((let (_menhir_stack, _, _menhir_s, _) = _menhir_stack in
            _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv168)) : 'freshtv170)
    | MenhirState0 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv183 * Lexing.position * _menhir_state * 'tv_expr) = Obj.magic _menhir_stack in
        ((assert (not _menhir_env._menhir_error);
        let _tok = _menhir_env._menhir_token in
        match _tok with
        | EOF ->
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv179 * Lexing.position * _menhir_state * 'tv_expr) = Obj.magic _menhir_stack in
            ((let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv177 * Lexing.position * _menhir_state * 'tv_expr) = Obj.magic _menhir_stack in
            ((let (_menhir_stack, _endpos__1_, _menhir_s, (_1 : 'tv_expr)) = _menhir_stack in
            let _2 = () in
            let _v : (
# 90 "src/parser.mly"
       (Ast.expr)
# 1496 "src/parser.ml"
            ) = 
# 183 "src/parser.mly"
                 ( _1 )
# 1500 "src/parser.ml"
             in
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv175) = _menhir_stack in
            let (_menhir_s : _menhir_state) = _menhir_s in
            let (_v : (
# 90 "src/parser.mly"
       (Ast.expr)
# 1508 "src/parser.ml"
            )) = _v in
            ((let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv173) = Obj.magic _menhir_stack in
            let (_menhir_s : _menhir_state) = _menhir_s in
            let (_v : (
# 90 "src/parser.mly"
       (Ast.expr)
# 1516 "src/parser.ml"
            )) = _v in
            ((let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv171) = Obj.magic _menhir_stack in
            let (_menhir_s : _menhir_state) = _menhir_s in
            let ((_1 : (
# 90 "src/parser.mly"
       (Ast.expr)
# 1524 "src/parser.ml"
            )) : (
# 90 "src/parser.mly"
       (Ast.expr)
# 1528 "src/parser.ml"
            )) = _v in
            (Obj.magic _1 : 'freshtv172)) : 'freshtv174)) : 'freshtv176)) : 'freshtv178)) : 'freshtv180)
        | _ ->
            assert (not _menhir_env._menhir_error);
            _menhir_env._menhir_error <- true;
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv181 * Lexing.position * _menhir_state * 'tv_expr) = Obj.magic _menhir_stack in
            ((let (_menhir_stack, _, _menhir_s, _) = _menhir_stack in
            _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv182)) : 'freshtv184)
    | MenhirState45 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ((('freshtv187) * Lexing.position * (
# 71 "src/parser.mly"
       (string)
# 1543 "src/parser.ml"
        ) * Lexing.position)) * Lexing.position * _menhir_state * 'tv_expr) = Obj.magic _menhir_stack in
        ((let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ((('freshtv185) * Lexing.position * (
# 71 "src/parser.mly"
       (string)
# 1549 "src/parser.ml"
        ) * Lexing.position)) * Lexing.position * _menhir_state * 'tv_expr) = Obj.magic _menhir_stack in
        ((let ((_menhir_stack, _endpos__2_, (_2 : (
# 71 "src/parser.mly"
       (string)
# 1554 "src/parser.ml"
        )), _startpos__2_), _endpos__4_, _, (_4 : 'tv_expr)) = _menhir_stack in
        let _3 = () in
        let _1 = () in
        let _endpos = _endpos__4_ in
        let _v : 'tv_stmt = 
# 133 "src/parser.mly"
                         ( _2, _4 )
# 1562 "src/parser.ml"
         in
        _menhir_goto_stmt _menhir_env _menhir_stack _endpos _v) : 'freshtv186)) : 'freshtv188)
    | _ ->
        _menhir_fail ()

and _menhir_run3 : _menhir_env -> 'ttv_tail -> _menhir_state -> 'ttv_return =
  fun _menhir_env _menhir_stack _menhir_s ->
    let _menhir_stack = (_menhir_stack, _menhir_s) in
    let _menhir_env = _menhir_discard _menhir_env in
    let _tok = _menhir_env._menhir_token in
    match _tok with
    | ID _v ->
        _menhir_run5 _menhir_env (Obj.magic _menhir_stack) _menhir_env._menhir_lexbuf.Lexing.lex_curr_p MenhirState3 _v _menhir_env._menhir_lexbuf.Lexing.lex_start_p
    | LEFT_ARRAY ->
        _menhir_run4 _menhir_env (Obj.magic _menhir_stack) _menhir_env._menhir_lexbuf.Lexing.lex_curr_p MenhirState3 _menhir_env._menhir_lexbuf.Lexing.lex_start_p
    | PRED _v ->
        _menhir_run2 _menhir_env (Obj.magic _menhir_stack) MenhirState3 _v _menhir_env._menhir_lexbuf.Lexing.lex_start_p
    | STRING _v ->
        _menhir_run1 _menhir_env (Obj.magic _menhir_stack) _menhir_env._menhir_lexbuf.Lexing.lex_curr_p MenhirState3 _v _menhir_env._menhir_lexbuf.Lexing.lex_start_p
    | RIGHT_PAREN ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv153) = Obj.magic _menhir_stack in
        let (_menhir_s : _menhir_state) = MenhirState3 in
        ((let _v : 'tv_loption_separated_nonempty_list_COMMA_expr__ = 
# 142 "<standard.mly>"
    ( [] )
# 1589 "src/parser.ml"
         in
        _menhir_goto_loption_separated_nonempty_list_COMMA_expr__ _menhir_env _menhir_stack _menhir_s _v) : 'freshtv154)
    | _ ->
        assert (not _menhir_env._menhir_error);
        _menhir_env._menhir_error <- true;
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState3

and _menhir_goto_option_goal_stmt_ : _menhir_env -> 'ttv_tail -> 'tv_option_goal_stmt_ -> Lexing.position -> 'ttv_return =
  fun _menhir_env _menhir_stack _v _startpos ->
    let _menhir_stack = (_menhir_stack, _v, _startpos) in
    let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : 'freshtv151 * 'tv_option_goal_stmt_ * Lexing.position) = Obj.magic _menhir_stack in
    ((assert (not _menhir_env._menhir_error);
    let _tok = _menhir_env._menhir_token in
    match _tok with
    | PRED _v ->
        _menhir_run60 _menhir_env (Obj.magic _menhir_stack) MenhirState58 _v _menhir_env._menhir_lexbuf.Lexing.lex_start_p
    | STRING _v ->
        _menhir_run59 _menhir_env (Obj.magic _menhir_stack) _menhir_env._menhir_lexbuf.Lexing.lex_curr_p MenhirState58 _v _menhir_env._menhir_lexbuf.Lexing.lex_start_p
    | COLON ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv149) = Obj.magic _menhir_stack in
        let (_menhir_s : _menhir_state) = MenhirState58 in
        ((let _v : 'tv_loption_separated_nonempty_list_COMMA_pattern__ = 
# 142 "<standard.mly>"
    ( [] )
# 1616 "src/parser.ml"
         in
        _menhir_goto_loption_separated_nonempty_list_COMMA_pattern__ _menhir_env _menhir_stack _menhir_s _v) : 'freshtv150)
    | _ ->
        assert (not _menhir_env._menhir_error);
        _menhir_env._menhir_error <- true;
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState58) : 'freshtv152)

and _menhir_goto_option_PURE_ : _menhir_env -> 'ttv_tail -> 'tv_option_PURE_ -> Lexing.position -> 'ttv_return =
  fun _menhir_env _menhir_stack _v _startpos ->
    let _menhir_stack = (_menhir_stack, _v, _startpos) in
    let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : 'freshtv147 * 'tv_option_PURE_ * Lexing.position) = Obj.magic _menhir_stack in
    ((assert (not _menhir_env._menhir_error);
    let _tok = _menhir_env._menhir_token in
    match _tok with
    | FUNCTION ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv143 * 'tv_option_PURE_ * Lexing.position) = Obj.magic _menhir_stack in
        ((let _menhir_env = _menhir_discard _menhir_env in
        let _tok = _menhir_env._menhir_token in
        match _tok with
        | ID _v ->
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : ('freshtv139 * 'tv_option_PURE_ * Lexing.position)) = Obj.magic _menhir_stack in
            let (_endpos : Lexing.position) = _menhir_env._menhir_lexbuf.Lexing.lex_curr_p in
            let (_v : (
# 71 "src/parser.mly"
       (string)
# 1645 "src/parser.ml"
            )) = _v in
            let (_startpos : Lexing.position) = _menhir_env._menhir_lexbuf.Lexing.lex_start_p in
            ((let _menhir_stack = (_menhir_stack, _endpos, _v, _startpos) in
            let _menhir_env = _menhir_discard _menhir_env in
            let _tok = _menhir_env._menhir_token in
            match _tok with
            | LEFT_PAREN ->
                _menhir_run28 _menhir_env (Obj.magic _menhir_stack) MenhirState82
            | _ ->
                assert (not _menhir_env._menhir_error);
                _menhir_env._menhir_error <- true;
                _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState82) : 'freshtv140)
        | _ ->
            assert (not _menhir_env._menhir_error);
            _menhir_env._menhir_error <- true;
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : ('freshtv141 * 'tv_option_PURE_ * Lexing.position)) = Obj.magic _menhir_stack in
            (raise _eRR : 'freshtv142)) : 'freshtv144)
    | _ ->
        assert (not _menhir_env._menhir_error);
        _menhir_env._menhir_error <- true;
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv145 * 'tv_option_PURE_ * Lexing.position) = Obj.magic _menhir_stack in
        (raise _eRR : 'freshtv146)) : 'freshtv148)

and _menhir_reduce23 : _menhir_env -> 'ttv_tail -> _menhir_state -> 'ttv_return =
  fun _menhir_env _menhir_stack _menhir_s ->
    let (_, _endpos) = Obj.magic _menhir_stack in
    let _v : 'tv_option_SEMICOLON_ = 
# 114 "<standard.mly>"
    ( None )
# 1677 "src/parser.ml"
     in
    _menhir_goto_option_SEMICOLON_ _menhir_env _menhir_stack _endpos _menhir_s _v

and _menhir_run41 : _menhir_env -> 'ttv_tail -> Lexing.position -> _menhir_state -> 'ttv_return =
  fun _menhir_env _menhir_stack _endpos _menhir_s ->
    let _menhir_env = _menhir_discard _menhir_env in
    let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : 'freshtv137) = Obj.magic _menhir_stack in
    let (_endpos_x_ : Lexing.position) = _endpos in
    let (_menhir_s : _menhir_state) = _menhir_s in
    ((let x = () in
    let _endpos = _endpos_x_ in
    let _v : 'tv_option_SEMICOLON_ = 
# 116 "<standard.mly>"
    ( Some x )
# 1693 "src/parser.ml"
     in
    _menhir_goto_option_SEMICOLON_ _menhir_env _menhir_stack _endpos _menhir_s _v) : 'freshtv138)

and _menhir_goto_option_params_decl_ : _menhir_env -> 'ttv_tail -> _menhir_state -> 'tv_option_params_decl_ -> 'ttv_return =
  fun _menhir_env _menhir_stack _menhir_s _v ->
    let _menhir_stack = (_menhir_stack, _menhir_s, _v) in
    let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : (('freshtv135 * Lexing.position) * Lexing.position * (
# 71 "src/parser.mly"
       (string)
# 1704 "src/parser.ml"
    ) * Lexing.position) * _menhir_state * 'tv_option_params_decl_) = Obj.magic _menhir_stack in
    ((assert (not _menhir_env._menhir_error);
    let _tok = _menhir_env._menhir_token in
    match _tok with
    | EQUALS ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : (('freshtv131 * Lexing.position) * Lexing.position * (
# 71 "src/parser.mly"
       (string)
# 1714 "src/parser.ml"
        ) * Lexing.position) * _menhir_state * 'tv_option_params_decl_) = Obj.magic _menhir_stack in
        ((let _menhir_env = _menhir_discard _menhir_env in
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : (('freshtv129 * Lexing.position) * Lexing.position * (
# 71 "src/parser.mly"
       (string)
# 1721 "src/parser.ml"
        ) * Lexing.position) * _menhir_state * 'tv_option_params_decl_) = Obj.magic _menhir_stack in
        ((let (((_menhir_stack, _startpos__1_), _endpos__2_, (_2 : (
# 71 "src/parser.mly"
       (string)
# 1726 "src/parser.ml"
        )), _startpos__2_), _, (_3 : 'tv_option_params_decl_)) = _menhir_stack in
        let _4 = () in
        let _1 = () in
        let _startpos = _startpos__1_ in
        let _v : 'tv_goal_stmt = 
# 138 "src/parser.mly"
    ( _2, match _3 with None -> [] | Some ps -> ps )
# 1734 "src/parser.ml"
         in
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv127) = _menhir_stack in
        let (_v : 'tv_goal_stmt) = _v in
        let (_startpos : Lexing.position) = _startpos in
        ((let _menhir_stack = (_menhir_stack, _v, _startpos) in
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv125 * 'tv_goal_stmt * Lexing.position) = Obj.magic _menhir_stack in
        ((assert (not _menhir_env._menhir_error);
        let _tok = _menhir_env._menhir_token in
        match _tok with
        | CODE _v ->
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv119 * 'tv_goal_stmt * Lexing.position) = Obj.magic _menhir_stack in
            let (_endpos : Lexing.position) = _menhir_env._menhir_lexbuf.Lexing.lex_curr_p in
            let (_v : (
# 63 "src/parser.mly"
       (Ast.code)
# 1753 "src/parser.ml"
            )) = _v in
            ((let _menhir_env = _menhir_discard _menhir_env in
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv117 * 'tv_goal_stmt * Lexing.position) = Obj.magic _menhir_stack in
            let (_endpos__2_ : Lexing.position) = _endpos in
            let ((_2 : (
# 63 "src/parser.mly"
       (Ast.code)
# 1762 "src/parser.ml"
            )) : (
# 63 "src/parser.mly"
       (Ast.code)
# 1766 "src/parser.ml"
            )) = _v in
            ((let (_menhir_stack, (_1 : 'tv_goal_stmt), _startpos__1_) = _menhir_stack in
            let _endpos = _endpos__2_ in
            let _v : 'tv_stmt = let _endpos = _endpos__2_ in
            let _startpos = _startpos__1_ in
            let _loc = (_startpos, _endpos) in
            
# 117 "src/parser.mly"
    (
      let name, params = _1 in
      name, Ast.EGoalDefn (_loc, (params, [], [], Some _2))
    )
# 1779 "src/parser.ml"
             in
            _menhir_goto_stmt _menhir_env _menhir_stack _endpos _v) : 'freshtv118)) : 'freshtv120)
        | COLON | PRED _ | STRING _ ->
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv121 * 'tv_goal_stmt * Lexing.position) = Obj.magic _menhir_stack in
            ((let (_menhir_stack, (x : 'tv_goal_stmt), _startpos_x_) = _menhir_stack in
            let _startpos = _startpos_x_ in
            let _v : 'tv_option_goal_stmt_ = 
# 116 "<standard.mly>"
    ( Some x )
# 1790 "src/parser.ml"
             in
            _menhir_goto_option_goal_stmt_ _menhir_env _menhir_stack _v _startpos) : 'freshtv122)
        | _ ->
            assert (not _menhir_env._menhir_error);
            _menhir_env._menhir_error <- true;
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv123 * 'tv_goal_stmt * Lexing.position) = Obj.magic _menhir_stack in
            (raise _eRR : 'freshtv124)) : 'freshtv126)) : 'freshtv128)) : 'freshtv130)) : 'freshtv132)
    | _ ->
        assert (not _menhir_env._menhir_error);
        _menhir_env._menhir_error <- true;
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : (('freshtv133 * Lexing.position) * Lexing.position * (
# 71 "src/parser.mly"
       (string)
# 1806 "src/parser.ml"
        ) * Lexing.position) * _menhir_state * 'tv_option_params_decl_) = Obj.magic _menhir_stack in
        ((let (_menhir_stack, _menhir_s, _) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv134)) : 'freshtv136)

and _menhir_goto_stmt : _menhir_env -> 'ttv_tail -> Lexing.position -> 'tv_stmt -> 'ttv_return =
  fun _menhir_env _menhir_stack _endpos _v ->
    let _menhir_stack = (_menhir_stack, _endpos, _v) in
    let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : ('freshtv115 * Lexing.position * 'tv_stmts * Lexing.position) * Lexing.position * 'tv_stmt) = Obj.magic _menhir_stack in
    ((assert (not _menhir_env._menhir_error);
    let _tok = _menhir_env._menhir_token in
    match _tok with
    | SEMICOLON ->
        _menhir_run41 _menhir_env (Obj.magic _menhir_stack) _menhir_env._menhir_lexbuf.Lexing.lex_curr_p MenhirState56
    | COLON | EOF | FUNCTION | GOAL | INCLUDE | LET | OPTINCLUDE | PRED _ | PREDICATE | PURE | STRING _ ->
        _menhir_reduce23 _menhir_env (Obj.magic _menhir_stack) MenhirState56
    | _ ->
        assert (not _menhir_env._menhir_error);
        _menhir_env._menhir_error <- true;
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState56) : 'freshtv116)

and _menhir_run28 : _menhir_env -> 'ttv_tail -> _menhir_state -> 'ttv_return =
  fun _menhir_env _menhir_stack _menhir_s ->
    let _menhir_stack = (_menhir_stack, _menhir_s) in
    let _menhir_env = _menhir_discard _menhir_env in
    let _tok = _menhir_env._menhir_token in
    match _tok with
    | ID _v ->
        _menhir_run29 _menhir_env (Obj.magic _menhir_stack) _menhir_env._menhir_lexbuf.Lexing.lex_curr_p MenhirState28 _v _menhir_env._menhir_lexbuf.Lexing.lex_start_p
    | RIGHT_PAREN ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv113) = Obj.magic _menhir_stack in
        let (_menhir_s : _menhir_state) = MenhirState28 in
        ((let _v : 'tv_loption_separated_nonempty_list_COMMA_param_decl__ = 
# 142 "<standard.mly>"
    ( [] )
# 1843 "src/parser.ml"
         in
        _menhir_goto_loption_separated_nonempty_list_COMMA_param_decl__ _menhir_env _menhir_stack _menhir_s _v) : 'freshtv114)
    | _ ->
        assert (not _menhir_env._menhir_error);
        _menhir_env._menhir_error <- true;
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState28

and _menhir_errorcase : _menhir_env -> 'ttv_tail -> _menhir_state -> 'ttv_return =
  fun _menhir_env _menhir_stack _menhir_s ->
    match _menhir_s with
    | MenhirState82 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : (('freshtv71 * 'tv_option_PURE_ * Lexing.position)) * Lexing.position * (
# 71 "src/parser.mly"
       (string)
# 1859 "src/parser.ml"
        ) * Lexing.position) = Obj.magic _menhir_stack in
        (raise _eRR : 'freshtv72)
    | MenhirState77 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv73 * _menhir_state * 'tv_pattern) * Lexing.position) = Obj.magic _menhir_stack in
        ((let ((_menhir_stack, _menhir_s, _), _) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv74)
    | MenhirState72 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : (('freshtv75 * 'tv_option_goal_stmt_ * Lexing.position) * _menhir_state * 'tv_patterns) * Lexing.position) = Obj.magic _menhir_stack in
        ((let ((_menhir_stack, _menhir_s, _), _) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv76)
    | MenhirState65 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv77 * _menhir_state * 'tv_pattern_param) * Lexing.position) = Obj.magic _menhir_stack in
        ((let ((_menhir_stack, _menhir_s, _), _) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv78)
    | MenhirState61 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv79) = Obj.magic _menhir_stack in
        (raise _eRR : 'freshtv80)
    | MenhirState58 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv81 * 'tv_option_goal_stmt_ * Lexing.position) = Obj.magic _menhir_stack in
        (raise _eRR : 'freshtv82)
    | MenhirState56 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv83 * Lexing.position * 'tv_stmts * Lexing.position) * Lexing.position * 'tv_stmt) = Obj.magic _menhir_stack in
        (raise _eRR : 'freshtv84)
    | MenhirState51 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv85 * Lexing.position) * Lexing.position * (
# 71 "src/parser.mly"
       (string)
# 1894 "src/parser.ml"
        ) * Lexing.position) = Obj.magic _menhir_stack in
        (raise _eRR : 'freshtv86)
    | MenhirState48 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : (('freshtv87 * Lexing.position * 'tv_stmts * Lexing.position)) * Lexing.position * (
# 82 "src/parser.mly"
       (Ast.substs)
# 1902 "src/parser.ml"
        ) * Lexing.position) = Obj.magic _menhir_stack in
        (raise _eRR : 'freshtv88)
    | MenhirState45 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : (('freshtv89) * Lexing.position * (
# 71 "src/parser.mly"
       (string)
# 1910 "src/parser.ml"
        ) * Lexing.position)) = Obj.magic _menhir_stack in
        (raise _eRR : 'freshtv90)
    | MenhirState40 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : (('freshtv91 * Lexing.position * 'tv_stmts * Lexing.position)) * Lexing.position * (
# 82 "src/parser.mly"
       (Ast.substs)
# 1918 "src/parser.ml"
        ) * Lexing.position) = Obj.magic _menhir_stack in
        (raise _eRR : 'freshtv92)
    | MenhirState32 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv93 * _menhir_state * 'tv_param_decl) * Lexing.position) = Obj.magic _menhir_stack in
        ((let ((_menhir_stack, _menhir_s, _), _) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv94)
    | MenhirState28 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv95 * _menhir_state) = Obj.magic _menhir_stack in
        ((let (_menhir_stack, _menhir_s) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv96)
    | MenhirState27 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv97 * Lexing.position) * (
# 85 "src/parser.mly"
       (string)
# 1936 "src/parser.ml"
        ) * Lexing.position) = Obj.magic _menhir_stack in
        (raise _eRR : 'freshtv98)
    | MenhirState17 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv99 * Lexing.position * _menhir_state * 'tv_expr) * Lexing.position) = Obj.magic _menhir_stack in
        ((let ((_menhir_stack, _, _menhir_s, _), _) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv100)
    | MenhirState9 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv101 * Lexing.position * _menhir_state * 'tv_expr) * Lexing.position) = Obj.magic _menhir_stack in
        ((let ((_menhir_stack, _, _menhir_s, _), _) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv102)
    | MenhirState5 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv103 * Lexing.position * _menhir_state * (
# 71 "src/parser.mly"
       (string)
# 1954 "src/parser.ml"
        ) * Lexing.position) = Obj.magic _menhir_stack in
        ((let (_menhir_stack, _, _menhir_s, _, _) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv104)
    | MenhirState4 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv105 * Lexing.position * _menhir_state * Lexing.position) = Obj.magic _menhir_stack in
        ((let (_menhir_stack, _, _menhir_s, _) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv106)
    | MenhirState3 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv107 * _menhir_state) = Obj.magic _menhir_stack in
        ((let (_menhir_stack, _menhir_s) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv108)
    | MenhirState2 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv109 * _menhir_state * (
# 85 "src/parser.mly"
       (string)
# 1973 "src/parser.ml"
        ) * Lexing.position) = Obj.magic _menhir_stack in
        ((let (_menhir_stack, _menhir_s, _, _) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv110)
    | MenhirState0 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv111) = Obj.magic _menhir_stack in
        (raise _eRR : 'freshtv112)

and _menhir_run1 : _menhir_env -> 'ttv_tail -> Lexing.position -> _menhir_state -> (
# 82 "src/parser.mly"
       (Ast.substs)
# 1985 "src/parser.ml"
) -> Lexing.position -> 'ttv_return =
  fun _menhir_env _menhir_stack _endpos _menhir_s _v _startpos ->
    let _menhir_env = _menhir_discard _menhir_env in
    let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : 'freshtv69) = Obj.magic _menhir_stack in
    let (_endpos__1_ : Lexing.position) = _endpos in
    let (_menhir_s : _menhir_state) = _menhir_s in
    let ((_1 : (
# 82 "src/parser.mly"
       (Ast.substs)
# 1996 "src/parser.ml"
    )) : (
# 82 "src/parser.mly"
       (Ast.substs)
# 2000 "src/parser.ml"
    )) = _v in
    let (_startpos__1_ : Lexing.position) = _startpos in
    ((let _endpos = _endpos__1_ in
    let _v : 'tv_expr = let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    
# 169 "src/parser.mly"
                 ( Ast.ESubsts (_loc, _1) )
# 2010 "src/parser.ml"
     in
    _menhir_goto_expr _menhir_env _menhir_stack _endpos _menhir_s _v) : 'freshtv70)

and _menhir_run2 : _menhir_env -> 'ttv_tail -> _menhir_state -> (
# 85 "src/parser.mly"
       (string)
# 2017 "src/parser.ml"
) -> Lexing.position -> 'ttv_return =
  fun _menhir_env _menhir_stack _menhir_s _v _startpos ->
    let _menhir_stack = (_menhir_stack, _menhir_s, _v, _startpos) in
    let _menhir_env = _menhir_discard _menhir_env in
    let _tok = _menhir_env._menhir_token in
    match _tok with
    | LEFT_PAREN ->
        _menhir_run3 _menhir_env (Obj.magic _menhir_stack) MenhirState2
    | _ ->
        assert (not _menhir_env._menhir_error);
        _menhir_env._menhir_error <- true;
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState2

and _menhir_run4 : _menhir_env -> 'ttv_tail -> Lexing.position -> _menhir_state -> Lexing.position -> 'ttv_return =
  fun _menhir_env _menhir_stack _endpos _menhir_s _startpos ->
    let _menhir_stack = (_menhir_stack, _endpos, _menhir_s, _startpos) in
    let _menhir_env = _menhir_discard _menhir_env in
    let _tok = _menhir_env._menhir_token in
    match _tok with
    | ID _v ->
        _menhir_run5 _menhir_env (Obj.magic _menhir_stack) _menhir_env._menhir_lexbuf.Lexing.lex_curr_p MenhirState4 _v _menhir_env._menhir_lexbuf.Lexing.lex_start_p
    | LEFT_ARRAY ->
        _menhir_run4 _menhir_env (Obj.magic _menhir_stack) _menhir_env._menhir_lexbuf.Lexing.lex_curr_p MenhirState4 _menhir_env._menhir_lexbuf.Lexing.lex_start_p
    | PRED _v ->
        _menhir_run2 _menhir_env (Obj.magic _menhir_stack) MenhirState4 _v _menhir_env._menhir_lexbuf.Lexing.lex_start_p
    | STRING _v ->
        _menhir_run1 _menhir_env (Obj.magic _menhir_stack) _menhir_env._menhir_lexbuf.Lexing.lex_curr_p MenhirState4 _v _menhir_env._menhir_lexbuf.Lexing.lex_start_p
    | RIGHT_ARRAY ->
        _menhir_reduce41 _menhir_env (Obj.magic _menhir_stack) MenhirState4
    | _ ->
        assert (not _menhir_env._menhir_error);
        _menhir_env._menhir_error <- true;
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState4

and _menhir_run5 : _menhir_env -> 'ttv_tail -> Lexing.position -> _menhir_state -> (
# 71 "src/parser.mly"
       (string)
# 2055 "src/parser.ml"
) -> Lexing.position -> 'ttv_return =
  fun _menhir_env _menhir_stack _endpos _menhir_s _v _startpos ->
    let _menhir_stack = (_menhir_stack, _endpos, _menhir_s, _v, _startpos) in
    let _menhir_env = _menhir_discard _menhir_env in
    let _tok = _menhir_env._menhir_token in
    match _tok with
    | LEFT_PAREN ->
        _menhir_run3 _menhir_env (Obj.magic _menhir_stack) MenhirState5
    | CODE _ | COLON | COMMA | EOF | FUNCTION | GOAL | INCLUDE | LET | OPTINCLUDE | PRED _ | PREDICATE | PURE | RIGHT_ARRAY | RIGHT_PAREN | SEMICOLON | STRING _ ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv67 * Lexing.position * _menhir_state * (
# 71 "src/parser.mly"
       (string)
# 2069 "src/parser.ml"
        ) * Lexing.position) = Obj.magic _menhir_stack in
        ((let (_menhir_stack, _endpos__1_, _menhir_s, (_1 : (
# 71 "src/parser.mly"
       (string)
# 2074 "src/parser.ml"
        )), _startpos__1_) = _menhir_stack in
        let _endpos = _endpos__1_ in
        let _v : 'tv_expr = let _endpos = _endpos__1_ in
        let _startpos = _startpos__1_ in
        let _loc = (_startpos, _endpos) in
        
# 167 "src/parser.mly"
                 ( Ast.EVar (_loc, _1) )
# 2083 "src/parser.ml"
         in
        _menhir_goto_expr _menhir_env _menhir_stack _endpos _menhir_s _v) : 'freshtv68)
    | _ ->
        assert (not _menhir_env._menhir_error);
        _menhir_env._menhir_error <- true;
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState5

and _menhir_goto_stmts : _menhir_env -> 'ttv_tail -> Lexing.position -> 'tv_stmts -> Lexing.position -> 'ttv_return =
  fun _menhir_env _menhir_stack _endpos _v _startpos ->
    let _menhir_stack = (_menhir_stack, _endpos, _v, _startpos) in
    let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : 'freshtv65 * Lexing.position * 'tv_stmts * Lexing.position) = Obj.magic _menhir_stack in
    ((assert (not _menhir_env._menhir_error);
    let _tok = _menhir_env._menhir_token in
    match _tok with
    | EOF ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv15 * Lexing.position * 'tv_stmts * Lexing.position) = Obj.magic _menhir_stack in
        ((let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv13 * Lexing.position * 'tv_stmts * Lexing.position) = Obj.magic _menhir_stack in
        ((let (_menhir_stack, _endpos__1_, (_1 : 'tv_stmts), _startpos__1_) = _menhir_stack in
        let _2 = () in
        let _v : (
# 89 "src/parser.mly"
       (Ast.expr Ast.Env.t)
# 2109 "src/parser.ml"
        ) = 
# 94 "src/parser.mly"
                 ( _1 )
# 2113 "src/parser.ml"
         in
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv11) = _menhir_stack in
        let (_v : (
# 89 "src/parser.mly"
       (Ast.expr Ast.Env.t)
# 2120 "src/parser.ml"
        )) = _v in
        ((let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv9) = Obj.magic _menhir_stack in
        let (_v : (
# 89 "src/parser.mly"
       (Ast.expr Ast.Env.t)
# 2127 "src/parser.ml"
        )) = _v in
        ((let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv7) = Obj.magic _menhir_stack in
        let ((_1 : (
# 89 "src/parser.mly"
       (Ast.expr Ast.Env.t)
# 2134 "src/parser.ml"
        )) : (
# 89 "src/parser.mly"
       (Ast.expr Ast.Env.t)
# 2138 "src/parser.ml"
        )) = _v in
        (Obj.magic _1 : 'freshtv8)) : 'freshtv10)) : 'freshtv12)) : 'freshtv14)) : 'freshtv16)
    | GOAL ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv25) = Obj.magic _menhir_stack in
        let (_startpos : Lexing.position) = _menhir_env._menhir_lexbuf.Lexing.lex_start_p in
        ((let _menhir_stack = (_menhir_stack, _startpos) in
        let _menhir_env = _menhir_discard _menhir_env in
        let _tok = _menhir_env._menhir_token in
        match _tok with
        | ID _v ->
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv21 * Lexing.position) = Obj.magic _menhir_stack in
            let (_endpos : Lexing.position) = _menhir_env._menhir_lexbuf.Lexing.lex_curr_p in
            let (_v : (
# 71 "src/parser.mly"
       (string)
# 2156 "src/parser.ml"
            )) = _v in
            let (_startpos : Lexing.position) = _menhir_env._menhir_lexbuf.Lexing.lex_start_p in
            ((let _menhir_stack = (_menhir_stack, _endpos, _v, _startpos) in
            let _menhir_env = _menhir_discard _menhir_env in
            let _tok = _menhir_env._menhir_token in
            match _tok with
            | LEFT_PAREN ->
                _menhir_run28 _menhir_env (Obj.magic _menhir_stack) MenhirState51
            | COLON | EOF | FUNCTION | GOAL | INCLUDE | LET | OPTINCLUDE | PRED _ | PREDICATE | PURE | SEMICOLON | STRING _ ->
                let (_menhir_env : _menhir_env) = _menhir_env in
                let (_menhir_stack : ('freshtv17 * Lexing.position) * Lexing.position * (
# 71 "src/parser.mly"
       (string)
# 2170 "src/parser.ml"
                ) * Lexing.position) = Obj.magic _menhir_stack in
                ((let ((_menhir_stack, _startpos__1_), _endpos__2_, (_2 : (
# 71 "src/parser.mly"
       (string)
# 2175 "src/parser.ml"
                )), _startpos__2_) = _menhir_stack in
                let _1 = () in
                let _endpos = _endpos__2_ in
                let _v : 'tv_stmt = let _endpos = _endpos__2_ in
                let _startpos = _startpos__1_ in
                let _loc = (_startpos, _endpos) in
                
# 122 "src/parser.mly"
    (
      _2, Ast.EGoalDefn (_loc, ([], [], [], None))
    )
# 2187 "src/parser.ml"
                 in
                _menhir_goto_stmt _menhir_env _menhir_stack _endpos _v) : 'freshtv18)
            | EQUALS ->
                let (_menhir_env : _menhir_env) = _menhir_env in
                let (_menhir_stack : 'freshtv19) = Obj.magic _menhir_stack in
                let (_menhir_s : _menhir_state) = MenhirState51 in
                ((let _v : 'tv_option_params_decl_ = 
# 114 "<standard.mly>"
    ( None )
# 2197 "src/parser.ml"
                 in
                _menhir_goto_option_params_decl_ _menhir_env _menhir_stack _menhir_s _v) : 'freshtv20)
            | _ ->
                assert (not _menhir_env._menhir_error);
                _menhir_env._menhir_error <- true;
                _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState51) : 'freshtv22)
        | _ ->
            assert (not _menhir_env._menhir_error);
            _menhir_env._menhir_error <- true;
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv23 * Lexing.position) = Obj.magic _menhir_stack in
            (raise _eRR : 'freshtv24)) : 'freshtv26)
    | INCLUDE ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv31 * Lexing.position * 'tv_stmts * Lexing.position) = Obj.magic _menhir_stack in
        ((let _menhir_env = _menhir_discard _menhir_env in
        let _tok = _menhir_env._menhir_token in
        match _tok with
        | STRING _v ->
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : ('freshtv27 * Lexing.position * 'tv_stmts * Lexing.position)) = Obj.magic _menhir_stack in
            let (_endpos : Lexing.position) = _menhir_env._menhir_lexbuf.Lexing.lex_curr_p in
            let (_v : (
# 82 "src/parser.mly"
       (Ast.substs)
# 2223 "src/parser.ml"
            )) = _v in
            let (_startpos : Lexing.position) = _menhir_env._menhir_lexbuf.Lexing.lex_start_p in
            ((let _menhir_stack = (_menhir_stack, _endpos, _v, _startpos) in
            let _menhir_env = _menhir_discard _menhir_env in
            let _tok = _menhir_env._menhir_token in
            match _tok with
            | SEMICOLON ->
                _menhir_run41 _menhir_env (Obj.magic _menhir_stack) _menhir_env._menhir_lexbuf.Lexing.lex_curr_p MenhirState48
            | COLON | EOF | FUNCTION | GOAL | INCLUDE | LET | OPTINCLUDE | PRED _ | PREDICATE | PURE | STRING _ ->
                _menhir_reduce23 _menhir_env (Obj.magic _menhir_stack) MenhirState48
            | _ ->
                assert (not _menhir_env._menhir_error);
                _menhir_env._menhir_error <- true;
                _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState48) : 'freshtv28)
        | _ ->
            assert (not _menhir_env._menhir_error);
            _menhir_env._menhir_error <- true;
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : ('freshtv29 * Lexing.position * 'tv_stmts * Lexing.position)) = Obj.magic _menhir_stack in
            (raise _eRR : 'freshtv30)) : 'freshtv32)
    | LET ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv41) = Obj.magic _menhir_stack in
        ((let _menhir_env = _menhir_discard _menhir_env in
        let _tok = _menhir_env._menhir_token in
        match _tok with
        | ID _v ->
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv37) = Obj.magic _menhir_stack in
            let (_endpos : Lexing.position) = _menhir_env._menhir_lexbuf.Lexing.lex_curr_p in
            let (_v : (
# 71 "src/parser.mly"
       (string)
# 2257 "src/parser.ml"
            )) = _v in
            let (_startpos : Lexing.position) = _menhir_env._menhir_lexbuf.Lexing.lex_start_p in
            ((let _menhir_stack = (_menhir_stack, _endpos, _v, _startpos) in
            let _menhir_env = _menhir_discard _menhir_env in
            let _tok = _menhir_env._menhir_token in
            match _tok with
            | EQUALS ->
                let (_menhir_env : _menhir_env) = _menhir_env in
                let (_menhir_stack : ('freshtv33) * Lexing.position * (
# 71 "src/parser.mly"
       (string)
# 2269 "src/parser.ml"
                ) * Lexing.position) = Obj.magic _menhir_stack in
                ((let _menhir_env = _menhir_discard _menhir_env in
                let _tok = _menhir_env._menhir_token in
                match _tok with
                | ID _v ->
                    _menhir_run5 _menhir_env (Obj.magic _menhir_stack) _menhir_env._menhir_lexbuf.Lexing.lex_curr_p MenhirState45 _v _menhir_env._menhir_lexbuf.Lexing.lex_start_p
                | LEFT_ARRAY ->
                    _menhir_run4 _menhir_env (Obj.magic _menhir_stack) _menhir_env._menhir_lexbuf.Lexing.lex_curr_p MenhirState45 _menhir_env._menhir_lexbuf.Lexing.lex_start_p
                | PRED _v ->
                    _menhir_run2 _menhir_env (Obj.magic _menhir_stack) MenhirState45 _v _menhir_env._menhir_lexbuf.Lexing.lex_start_p
                | STRING _v ->
                    _menhir_run1 _menhir_env (Obj.magic _menhir_stack) _menhir_env._menhir_lexbuf.Lexing.lex_curr_p MenhirState45 _v _menhir_env._menhir_lexbuf.Lexing.lex_start_p
                | _ ->
                    assert (not _menhir_env._menhir_error);
                    _menhir_env._menhir_error <- true;
                    _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState45) : 'freshtv34)
            | _ ->
                assert (not _menhir_env._menhir_error);
                _menhir_env._menhir_error <- true;
                let (_menhir_env : _menhir_env) = _menhir_env in
                let (_menhir_stack : ('freshtv35) * Lexing.position * (
# 71 "src/parser.mly"
       (string)
# 2293 "src/parser.ml"
                ) * Lexing.position) = Obj.magic _menhir_stack in
                (raise _eRR : 'freshtv36)) : 'freshtv38)
        | _ ->
            assert (not _menhir_env._menhir_error);
            _menhir_env._menhir_error <- true;
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv39) = Obj.magic _menhir_stack in
            (raise _eRR : 'freshtv40)) : 'freshtv42)
    | OPTINCLUDE ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv47 * Lexing.position * 'tv_stmts * Lexing.position) = Obj.magic _menhir_stack in
        ((let _menhir_env = _menhir_discard _menhir_env in
        let _tok = _menhir_env._menhir_token in
        match _tok with
        | STRING _v ->
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : ('freshtv43 * Lexing.position * 'tv_stmts * Lexing.position)) = Obj.magic _menhir_stack in
            let (_endpos : Lexing.position) = _menhir_env._menhir_lexbuf.Lexing.lex_curr_p in
            let (_v : (
# 82 "src/parser.mly"
       (Ast.substs)
# 2315 "src/parser.ml"
            )) = _v in
            let (_startpos : Lexing.position) = _menhir_env._menhir_lexbuf.Lexing.lex_start_p in
            ((let _menhir_stack = (_menhir_stack, _endpos, _v, _startpos) in
            let _menhir_env = _menhir_discard _menhir_env in
            let _tok = _menhir_env._menhir_token in
            match _tok with
            | SEMICOLON ->
                _menhir_run41 _menhir_env (Obj.magic _menhir_stack) _menhir_env._menhir_lexbuf.Lexing.lex_curr_p MenhirState40
            | COLON | EOF | FUNCTION | GOAL | INCLUDE | LET | OPTINCLUDE | PRED _ | PREDICATE | PURE | STRING _ ->
                _menhir_reduce23 _menhir_env (Obj.magic _menhir_stack) MenhirState40
            | _ ->
                assert (not _menhir_env._menhir_error);
                _menhir_env._menhir_error <- true;
                _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState40) : 'freshtv44)
        | _ ->
            assert (not _menhir_env._menhir_error);
            _menhir_env._menhir_error <- true;
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : ('freshtv45 * Lexing.position * 'tv_stmts * Lexing.position)) = Obj.magic _menhir_stack in
            (raise _eRR : 'freshtv46)) : 'freshtv48)
    | PREDICATE ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv53) = Obj.magic _menhir_stack in
        let (_startpos : Lexing.position) = _menhir_env._menhir_lexbuf.Lexing.lex_start_p in
        ((let _menhir_stack = (_menhir_stack, _startpos) in
        let _menhir_env = _menhir_discard _menhir_env in
        let _tok = _menhir_env._menhir_token in
        match _tok with
        | PRED _v ->
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv49 * Lexing.position) = Obj.magic _menhir_stack in
            let (_v : (
# 85 "src/parser.mly"
       (string)
# 2350 "src/parser.ml"
            )) = _v in
            let (_startpos : Lexing.position) = _menhir_env._menhir_lexbuf.Lexing.lex_start_p in
            ((let _menhir_stack = (_menhir_stack, _v, _startpos) in
            let _menhir_env = _menhir_discard _menhir_env in
            let _tok = _menhir_env._menhir_token in
            match _tok with
            | LEFT_PAREN ->
                _menhir_run28 _menhir_env (Obj.magic _menhir_stack) MenhirState27
            | _ ->
                assert (not _menhir_env._menhir_error);
                _menhir_env._menhir_error <- true;
                _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState27) : 'freshtv50)
        | _ ->
            assert (not _menhir_env._menhir_error);
            _menhir_env._menhir_error <- true;
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv51 * Lexing.position) = Obj.magic _menhir_stack in
            (raise _eRR : 'freshtv52)) : 'freshtv54)
    | PURE ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv57) = Obj.magic _menhir_stack in
        let (_startpos : Lexing.position) = _menhir_env._menhir_lexbuf.Lexing.lex_start_p in
        ((let _menhir_env = _menhir_discard _menhir_env in
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv55) = Obj.magic _menhir_stack in
        let (_startpos_x_ : Lexing.position) = _startpos in
        ((let x = () in
        let _startpos = _startpos_x_ in
        let _v : 'tv_option_PURE_ = 
# 116 "<standard.mly>"
    ( Some x )
# 2382 "src/parser.ml"
         in
        _menhir_goto_option_PURE_ _menhir_env _menhir_stack _v _startpos) : 'freshtv56)) : 'freshtv58)
    | COLON | PRED _ | STRING _ ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv59) = Obj.magic _menhir_stack in
        ((let (_, _startpos) = Obj.magic _menhir_stack in
        let _v : 'tv_option_goal_stmt_ = 
# 114 "<standard.mly>"
    ( None )
# 2392 "src/parser.ml"
         in
        _menhir_goto_option_goal_stmt_ _menhir_env _menhir_stack _v _startpos) : 'freshtv60)
    | FUNCTION ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv61) = Obj.magic _menhir_stack in
        ((let (_, _startpos) = Obj.magic _menhir_stack in
        let _v : 'tv_option_PURE_ = 
# 114 "<standard.mly>"
    ( None )
# 2402 "src/parser.ml"
         in
        _menhir_goto_option_PURE_ _menhir_env _menhir_stack _v _startpos) : 'freshtv62)
    | _ ->
        assert (not _menhir_env._menhir_error);
        _menhir_env._menhir_error <- true;
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv63 * Lexing.position * 'tv_stmts * Lexing.position) = Obj.magic _menhir_stack in
        (raise _eRR : 'freshtv64)) : 'freshtv66)

and _menhir_discard : _menhir_env -> _menhir_env =
  fun _menhir_env ->
    let lexer = _menhir_env._menhir_lexer in
    let lexbuf = _menhir_env._menhir_lexbuf in
    let _tok = lexer lexbuf in
    {
      _menhir_lexer = lexer;
      _menhir_lexbuf = lexbuf;
      _menhir_token = _tok;
      _menhir_error = false;
    }

and _menhir_init : (Lexing.lexbuf -> token) -> Lexing.lexbuf -> _menhir_env =
  fun lexer lexbuf ->
    let _tok = Obj.magic () in
    {
      _menhir_lexer = lexer;
      _menhir_lexbuf = lexbuf;
      _menhir_token = _tok;
      _menhir_error = false;
    }

and expr_only : (Lexing.lexbuf -> token) -> Lexing.lexbuf -> (
# 90 "src/parser.mly"
       (Ast.expr)
# 2437 "src/parser.ml"
) =
  fun lexer lexbuf ->
    let _menhir_env = _menhir_init lexer lexbuf in
    Obj.magic (let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : 'freshtv5) = ((), _menhir_env._menhir_lexbuf.Lexing.lex_curr_p) in
    ((let _menhir_env = _menhir_discard _menhir_env in
    let _tok = _menhir_env._menhir_token in
    match _tok with
    | ID _v ->
        _menhir_run5 _menhir_env (Obj.magic _menhir_stack) _menhir_env._menhir_lexbuf.Lexing.lex_curr_p MenhirState0 _v _menhir_env._menhir_lexbuf.Lexing.lex_start_p
    | LEFT_ARRAY ->
        _menhir_run4 _menhir_env (Obj.magic _menhir_stack) _menhir_env._menhir_lexbuf.Lexing.lex_curr_p MenhirState0 _menhir_env._menhir_lexbuf.Lexing.lex_start_p
    | PRED _v ->
        _menhir_run2 _menhir_env (Obj.magic _menhir_stack) MenhirState0 _v _menhir_env._menhir_lexbuf.Lexing.lex_start_p
    | STRING _v ->
        _menhir_run1 _menhir_env (Obj.magic _menhir_stack) _menhir_env._menhir_lexbuf.Lexing.lex_curr_p MenhirState0 _v _menhir_env._menhir_lexbuf.Lexing.lex_start_p
    | _ ->
        assert (not _menhir_env._menhir_error);
        _menhir_env._menhir_error <- true;
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState0) : 'freshtv6))

and file : (Lexing.lexbuf -> token) -> Lexing.lexbuf -> (
# 89 "src/parser.mly"
       (Ast.expr Ast.Env.t)
# 2462 "src/parser.ml"
) =
  fun lexer lexbuf ->
    let _menhir_env = _menhir_init lexer lexbuf in
    Obj.magic (let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : 'freshtv3) = ((), _menhir_env._menhir_lexbuf.Lexing.lex_curr_p) in
    ((let _menhir_env = _menhir_discard _menhir_env in
    let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : 'freshtv1) = Obj.magic _menhir_stack in
    ((let (_, _startpos) = Obj.magic _menhir_stack in
    let _endpos = _startpos in
    let _v : 'tv_stmts = 
# 98 "src/parser.mly"
                 ( Ast.Env.empty )
# 2476 "src/parser.ml"
     in
    _menhir_goto_stmts _menhir_env _menhir_stack _endpos _v _startpos) : 'freshtv2)) : 'freshtv4))

# 269 "<standard.mly>"
  

# 2483 "src/parser.ml"
